//EditElementList function of EditUniverseWindow soi0.1

#include "windowGuts.h"
#include <memory>
#include "myButton.h"
#include "designButtons.h"
#include "editUniverseWindow.h"
#include "bottomLine.h"
#include "myStringDrawer.h"
#include "editElementWindow.h"

void EditUniverseWindow::EditElementList(void) {
//debug error check these news

BRect editWindowRect(40,45, 632,473);
try {
	editElementWindow = new EditElementWindow(editWindowRect, editThe[ELEMENT_TYPE]);
}
catch (...) {
	warning(failEditWindow);
	return;
}
editElementWindow->Lock();


char prelimElectron[UINTSTRLEN];
char prelimNeutron[UINTSTRLEN];
char prelimProton[UINTSTRLEN];
char * prelimName;
char prelimVolume[UINTSTRLEN];
char prelimVPer[UINTSTRLEN];
int32 mode;
if (elementCurrent) {
	SPRTF(prelimElectron, "%u", elementCurrent->electron);
	SPRTF(prelimNeutron, "%u", elementCurrent->neutron);
	SPRTF(prelimProton, "%u", elementCurrent->proton);
	prelimName = elementCurrent->name;
	SPRTF(prelimVolume, "%u", elementCurrent->volume);
	SPRTF(prelimVPer, "%u", elementCurrent->vper);
	mode = SOI_BLREMOVE;
}
else {
	prelimElectron[0] = NULL;
	prelimNeutron[0] = NULL;
	prelimProton[0] = NULL;
	prelimName = NULL;
	prelimVolume[0] = NULL;
	prelimVPer[0] = NULL;
	mode = SOI_BLADD;
}
BRect nameRect(10,2, 580,18);
try {
	auto_ptr<BMessage> msg(new BMessage(SOI_NAMEELEMENT));
	editElementWindow->nameStrGadget = new StringGadget(nameRect, nameGadgetStr, nameOf[ELEMENT_TYPE], prelimName, msg.get(), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	msg.release();
}
catch (...) {
	warning(failStringGadget);
	goto bad;
}
editElementWindow->nameStrGadget->SetAlignment(B_ALIGN_RIGHT, B_ALIGN_LEFT);
editElementWindow->nameStrGadget->SetDivider(180.0);
if (mode == SOI_BLADD) editElementWindow->nameStrGadget->makeFocus = true;
editElementWindow->AddChild(editElementWindow->nameStrGadget);

int32 top = 22;
int32 left = 10;
int32 width = 235;
int32 height = 18;
int32 vgap = 23;//height + Vspacing
float divider = 160.0;

BRect eRect(left,top, width,top + height);
try {
	auto_ptr<BMessage> msg(new BMessage(SOI_ELECTRONELEMENT));
	editElementWindow->eIntGadget = new IntGadget(eRect, eGadgetStr, numElementalElectrons, prelimElectron, msg.get(), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	msg.release();
}
catch (...) {
	warning(failIntGadget);
	goto bad;
}
editElementWindow->eIntGadget->SetAlignment(B_ALIGN_RIGHT, B_ALIGN_LEFT);
editElementWindow->eIntGadget->SetDivider(divider);
editElementWindow->AddChild(editElementWindow->eIntGadget);

top += vgap;
BRect nRect(left,top, width,top + height);
try {
	auto_ptr<BMessage> msg(new BMessage(SOI_NEUTRONELEMENT));
	editElementWindow->nIntGadget = new IntGadget(nRect, nGadgetStr, numElementalNeutrons, prelimNeutron, msg.get(), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	msg.release();
}
catch (...) {
	warning(failIntGadget);
	goto bad;
}
editElementWindow->nIntGadget->SetAlignment(B_ALIGN_RIGHT, B_ALIGN_LEFT);
editElementWindow->nIntGadget->SetDivider(divider);
editElementWindow->AddChild(editElementWindow->nIntGadget);

top += vgap;
BRect pRect(left,top, width,top + height);
try {
	auto_ptr<BMessage> msg(new BMessage(SOI_NELEMENT));
	editElementWindow->pIntGadget = new IntGadget(pRect, pGadgetStr, numElementalProtons, prelimProton, msg.get(), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	msg.release();
}
catch (...) {
	warning(failIntGadget);
	goto bad;
}
editElementWindow->pIntGadget->SetAlignment(B_ALIGN_RIGHT, B_ALIGN_LEFT);
editElementWindow->pIntGadget->SetDivider(divider);
editElementWindow->AddChild(editElementWindow->pIntGadget);

top += vgap;
BRect vRect(left,top, width,top + height);
try {
	auto_ptr<BMessage> msg(new BMessage(SOI_VOLUMEELEMENT));
	editElementWindow->vIntGadget = new IntGadget(vRect, vGadgetStr, numVolumeStr, prelimVolume, msg.get(), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	msg.release();
}
catch (...) {
	warning(failIntGadget);
	goto bad;
}
editElementWindow->vIntGadget->SetAlignment(B_ALIGN_RIGHT, B_ALIGN_LEFT);
editElementWindow->vIntGadget->SetDivider(divider);
editElementWindow->AddChild(editElementWindow->vIntGadget);

BRect vperRect(left + 195,top, left + 195 + width,top + height);
try {
	auto_ptr<BMessage> msg(new BMessage(SOI_VPERELEMENT));
	editElementWindow->vperIntGadget = new IntGadget(vperRect, vperGadgetStr, numVPerStr, prelimVPer, msg.get(), B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_NAVIGABLE);
	msg.release();
}
catch (...) {
	warning(failIntGadget);
	goto bad;
}
editElementWindow->vperIntGadget->SetAlignment(B_ALIGN_RIGHT, B_ALIGN_LEFT);
editElementWindow->vperIntGadget->SetDivider(divider);
editElementWindow->AddChild(editElementWindow->vperIntGadget);
try {
	editElementWindow->strView = new MyStringDrawer(BRect(445,top - 2,600,top + 20));
}
catch (...) {
	warning(failMyStringDrawer);
	goto bad;
}
if (!editElementWindow->strView->SetText(itemsOfStr[ELEMENT_TYPE])) goto bad;
editElementWindow->AddChild(editElementWindow->strView);

bool save = false;
if (dataListGlobal[ELEMENT_TYPE]->list->CountItems()) save = true;
editElementWindow->bottom = 401;
BottomLine(ELEMENT_TYPE, (EditUniverseWindow * )editElementWindow, editElementWindow->bottom, editElementWindow->bb, mode, save);
editElementWindow->thisDNPtr = dataListGlobal[ELEMENT_TYPE]->NextPrevItems((void *)elementCurrent, &editElementWindow->nextDNPtr, &editElementWindow->prevDNPtr, editElementWindow->bb);
bad:
editElementWindow->Unlock();
editElementWindow->Show();
}//end