//holeAffects.cpp

#include "error.h"
#include "Xwarning.h"
#include "def.h"
#include "constants.h"
#include "holeAffects.h"

HoleAffects		::		HoleAffects() 
{
	destroy = false;
	destroyRate = 1.0;
	sendToUniverse = 0;
	sendToGalaxy = 0;
	sendToX = 1;
	sendToY = 1;
	sendToZ = 1;
}//end


HoleAffects	::	~HoleAffects() 
{
	//left blank
}//end


bool 
HoleAffects	::	HoleAffectsSave(	BFile * file) 
{
	int32 len = sizeof(destroy);
	if (!(file->Write(&destroy, len) == len)) return false;
	len = sizeof(destroyRate);
	if (!(file->Write(&destroyRate, len) == len)) return false;
	len = sizeof(sendToUniverse);
	if (!(file->Write(&sendToUniverse, len) == len)) return false;
	//len = sizeof(sendToGalaxy);
	if (!(file->Write(&sendToGalaxy, len) == len)) return false;
	len = sizeof(sendToX);
	if (!(file->Write(&sendToX, len) == len)) return false;
	//len = sizeof(sendToY);
	if (!(file->Write(&sendToY, len) == len)) return false;
	//len = sizeof(sendToZ);
	if (file->Write(&sendToZ, len) == len) return true;
	else return false;
}//end


bool 
HoleAffects	::	HoleAffectsLoad(	BFile * file) 
{
	int32 len = sizeof(destroy);
	if (file->Read(&destroy, len) == len) 
	{
		len = sizeof(destroyRate);
		if (file->Read(&destroyRate, len) == len) 
		{
			len = sizeof(sendToUniverse);
			if (file->Read(&sendToUniverse, len) == len) 
			{
				//len = sizeof(sendToGalaxy);
				if (file->Read(&sendToGalaxy, len) == len) 
				{
					len = sizeof(sendToX);
					if (file->Read(&sendToX, len) == len) 
					{
						//len = sizeof(sendToY);
						if (file->Read(&sendToY, len) == len) 
						{
							//len = sizeof(sendToZ);
							if (file->Read(&sendToZ, len) == len) 
							{
								return true;
							}
						}
					}
				}
			}
		}
	}
	warning(badFileLength);
	return false;
}//end
