//globals.cpp

#include "Xthings.h"
#include "Dstar.h"
#include "DnumSpecificWindows.h"
#include "XnullGlobals.h"
#include "Xglobals.h"
#include "globals.h"
#include "Xui32RandBetween.h"
#include "preferences.h"
#include "myPreferences.h"
#include "themAll.h"
#include "Xwarning.h"
#include "Xunique.h"
#include "dobj.h"
#include "def.h"
#include "error.h"
#include "mergeHow.h"
#include "mergeNode.h"
#include "mergeList.h"
#include "dataNode.h"
#include "dataList.h"
#include "XuIntPtrNode.h"
#include "uIntPtrNode.h"
#include "ptrList.h"
#include "mPtrNode.h"
#include "myroColour.h"
#include "XmyApp.h"
#include "myApp.h"

uint32 
	kindVersion[NUMTHINGS][2] = 
	{
		{0, 0},//file save [version][revision]
		{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, 
		{0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, {0, 0}, 
		{0, 0}, {0, 0}, {0, 0}
	},
	IDs[NUMTHINGS];
MyPreferences * myPrefs;
MyApp * myApp;
int32 err;


class Universe;
Universe	* universe = NULL,
			* universeCurrent = NULL,
			* universeNewCurrent = NULL;
class Galaxy;
Galaxy	* galaxy = NULL,
		* galaxyCurrent = NULL,
		* galaxyNewCurrent = NULL;
class Species;
Species	* species = NULL,
		* speciesCurrent = NULL,
		* speciesNewCurrent = NULL;
class Wormhole;
Wormhole	* wormhole = NULL,
			* wormholeCurrent = NULL,
			* wormholeNewCurrent = NULL;
class Blackhole;
Blackhole	* blackhole = NULL,
			* blackholeCurrent = NULL,
			* blackholeNewCurrent = NULL;
class Star;
Star	* star = NULL,
		* starCurrent = NULL,
		* starNewCurrent = NULL;
class Planet;
Planet	* planet = NULL,
		* planetCurrent = NULL,
		* planetNewCurrent = NULL;
class Ship;
Ship	* ship = NULL,
		* shipCurrent = NULL,
		* shipNewCurrent = NULL;
class PlanetWeapon;
PlanetWeapon	* planetWeapon = NULL,
				* planetWeaponCurrent = NULL,
				* planetWeaponNewCurrent = NULL;
class PlanetShield;
PlanetShield	* planetShield = NULL,
				* planetShieldCurrent = NULL,
				* planetShieldNewCurrent = NULL;
class ShipShield;
ShipShield	* shipShield = NULL,
			* shipShieldCurrent = NULL,
			* shipShieldNewCurrent = NULL;
class ShipWeapon;
ShipWeapon	* shipWeapon = NULL,
			* shipWeaponCurrent = NULL,
			* shipWeaponNewCurrent = NULL;
class Engine;
Engine	* engine = NULL,
		* engineCurrent = NULL,
		* engineNewCurrent = NULL;
class Factory;
Factory	* factory = NULL,
		* factoryCurrent = NULL,
		* factoryNewCurrent = NULL;
class Mine;
Mine	* mine = NULL,
		* mineCurrent = NULL,
		* mineNewCurrent = NULL;
class Compound;
Compound	* compound = NULL,
			* compoundCurrent = NULL,
			* compoundNewCurrent = NULL;
class Element;
Element	* element = NULL,
		* elementCurrent = NULL,
		* elementNewCurrent = NULL;
class UniversalConstants;
UniversalConstants	* universalConstants = NULL,
					* universalConstantsCurrent = NULL,
					* universalConstantsNewCurrent = NULL;
class DataList;
DataList * dataListGlobal[NUMTHINGS];


//const char
//	* defaultStrengthStr = "Default Strength:",
//	* defaultStrengthErr = "Default strength must be a floating point32 number betweeen 0 and 1 inclusive",
//	* noShowUntilAdd = "Cannot show things until item is added",
//	* saveThe[NUMTHINGS] = {
//		"Save the Universe",
//		"Save the Galaxy list",
//		"Save the Blackhole list",
//		"Save the Wormhole list",
//		"Save the Star list",
//		"Save the Planet list",
//		"Save the Planet Shield list",
//		"Save the Planet Weapon list",
//		"Save the Ship list",
//		"Save the Ship Shield list",
//		"Save the Ship Weapon list",
//		"Save the Engine list",
//		"Save the Factory list",
//		"Save the Mine list",
//		"Save the Compound list",
//		"Save the Element list",
//		"Save the Species list",
//		"Save the Universal Constants"
//	},
//	* loadThe[NUMTHINGS] = {
//		"Load an Universe",
//		"Load a Galaxy list",
//		"Load a Blackhole list",
//		"Load a Wormhole list",
//		"Load a Star list",
//		"Load a Planet list",
//		"Load a Planet Shield list",
//		"Load a Planet Weapon list",
//		"Load a Ship list",
//		"Load a Ship Shield list",
//		"Load a Ship Weapon list",
//		"Load an Engine list",
//		"Load a Factory list",
//		"Load a Mine list",
//		"Load a Compound list",
//		"Load an Element list",
//		"Load a Species list",
//		"Load Universal Constants"
//	},
//	* nothingToLoad[NUMTHINGS] = {
//		"No Universe to load",
//		"No Galaxy to load",
//		"No Blackhole to load",
//		"No Wormhole to load",
//		"No Star to load",
//		"No Planet to load",
//		"No Planet Shield to load",
//		"No Planet Weapon to load",
//		"No Ship to load",
//		"No Ship Shield to load",
//		"No Ship Weapon to load",
//		"No Engine to load",
//		"No Factory to load",
//		"No Mine to load",
//		"No Compound to load",
//		"No Element to load",
//		"No Species to load",
//		"No Universal Constants"
//	},
//	* selectE4C = "Select Element(s) For This Element",
//	* showEofC = "Show  Element(s) For This Compound",
//	* selectC4C = "Select Compound(s) For This Compound",
//	* showCofC = "Show  Compound(s) For This Compound",
//	* wGalaxy = " Galaxy's Width (X):  Min",
//	* hGalaxy = " Galaxy's Height (Y):  Min",
//	* dGalaxy = " Galaxy's Depth (Z):  Min",
//	* galaxyWErr = " Galaxy's Width value needs to be a positive integer, less than 4294967295l",
//	* galaxyHErr = " Galaxy's Height value needs to be a positive integer, less than 4294967295l",
//	* galaxyDErr = " Galaxy's Depth value needs to be a positive integer, less than 4294967295l",
//	* xLocStr = "X Dimension Location",
//	* yLocStr = "Y Dimension Location",
//	* zLocStr = "Z Dimension Location",
//	* getPossAffectStr = "Get Possible Affects",
//	* getPossOrderStr = "Get Possible Orders",
//	* nameOf[NUMTHINGS] = {
//		"Name of Universe:",
//		"Name of Galaxy:",
//		"Name of Blackhole:",
//		"Name of Wormhole:",
//		"Name of Star:",
//		"Name of Planet:",
//		"Name of Planet Shield:",
//		"Name of Planet Weapon:",
//		"Name of Ship:",
//		"Name of Ship Shield:",
//		"Name of Ship Weapon:",
//		"Name of Engine:",
//		"Name of Factory:",
//		"Name of Mine:",
//		"Name of Compound:",
//		"Name of Element:",
//		"Name of Species:",
//		"Name of Universal Constants:"
//	},
//	* setKindStr = "Set Kind"

// * itemsOfStr[NUMTHINGS] = {
//		" Universe(s)",
//		" Galaxy(s)",
//		" Blackhole(s)",
//		" Wormhole(s)",
//		" Star(s)",
//		" Planet(s)",
//		" Planet Shield(s)",
//		" Planet Weapon(s)",
//		" Ship(s)",
//		" Ship Shield(s)",
//		" Ship Weapon(s)",
//		" Engine(s)",
//		" Factory(s)",
//		" Mine(s)",
//		" Compound(s)",
//		" Element(s)",
//		" Species(s)",
//		"Universal Constants"
//	},
//	* fuelAPerStr = "per unit mass for propulsion drive",
//	* fuelUsedPerStr = "fuel unit(s) per unit mass per distance unit",
//	* ftlAStr = "per unit mass for ftl drive";


////I will remove the erroneous 's and use in the real thing editors...
////	* xGalaxy = " Galaxy's X Location:",
////	* yGalaxy = " Galaxy's Y Location:",
////	* zGalaxy = " Galaxy's Z Location:",
////	* xPlanet = " Planet's X Location:",
////	* yPlanet = " Planet's Y Location:",
////	* zPlanet = " Planet's Z Location:",
////	* xStar = " Star's X Location:",
////	* yStar = " Star's Y Location:",
////	* zStar = " Star's Z Location:",
////	* xWormhole = " Wormhole's X Location:",
////	* yWormhole = " Wormhole's Y Location:",
////	* zWormhole = " Wormhole's Z Location:",
////	* xBlackhole = " Blackhole's X Location:",
////	* yBlackhole = " Blackhole's Y Location:",
////	* zBlackhole = " Blackhole's Z Location:";

void
FillGlobalsFromResources(	void)
{
	NullGlobals();
	BResources * appResources = myApp->AppResources();
	size_t len;	
	VerifyCancel = (const char *)appResources->FindResource('CSTR', "VerifyCancel", &len);
	VerifyDoNot = (const char *)appResources->FindResource('CSTR', "VerifyDoNot", &len);
	cIDMsg = (const char *)appResources->FindResource('CSTR', "cIDMsg", &len);
	AppSignature = (const char *)appResources->FindResource('CSTR', "AppSignature", &len);
	VerifyTitle = (const char *)appResources->FindResource('CSTR', "VerifyTitle", &len);
	VerifyDo = (const char *)appResources->FindResource('CSTR', "VerifyDo", &len);
	TitleWindowTitle = (const char *)appResources->FindResource('CSTR', "TitleWindowTitle", &len);
	FailTitleWindow = (const char *)appResources->FindResource('CSTR', "FailTitleWindow", &len);
	FailCreateAll = (const char *)appResources->FindResource('CSTR', "FailCreateAll", &len);
	classGadgetLabelStr = (const char *)appResources->FindResource('CSTR', "classGadgetLabelStr", &len);
	MinOriginStarClassText = (const char *)appResources->FindResource('CSTR', "MinOriginStarClassText", &len);
	MaxOriginStarClassText = (const char *)appResources->FindResource('CSTR', "MaxOriginStarClassText", &len);
	ProgramName = (const char *)appResources->FindResource('CSTR', "ProgramName", &len);
	ProgramNameSubTitle = (const char *)appResources->FindResource('CSTR', "ProgramNameSubTitle", &len);
	CreateNewLable = (const char *)appResources->FindResource('CSTR', "CreateNewLable", &len);
	LoadPreviousLable = (const char *)appResources->FindResource('CSTR', "LoadPreviousLable", &len);
	SaveLable = (const char *)appResources->FindResource('CSTR', "SaveLable", &len);
	RealLable = (const char *)appResources->FindResource('CSTR', "RealLable", &len);
	AboutMenuLable = (const char *)appResources->FindResource('CSTR', "AboutMenuLable", &len);
	FontFamilyPUMLabel = (const char *)appResources->FindResource('CSTR', "FontFamilyPUMLabel", &len);
	FontStylePUMLabel = (const char *)appResources->FindResource('CSTR', "FontStylePUMLabel", &len);
	AboutPrefPanelWindow = (const char *)appResources->FindResource('CSTR', "AboutPrefPanelWindow", &len);
	AboutTitleWindowMsg1 = (const char *)appResources->FindResource('CSTR', "AboutTitleWindowMsg1", &len);
	AboutTitleWindowMsg2 = (const char *)appResources->FindResource('CSTR', "AboutTitleWindowMsg2", &len);
	AboutListViewWindow = (const char *)appResources->FindResource('CSTR', "AboutListViewWindow", &len);
	AboutEditUniverseWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditUniverseWindowMsg", &len);
	AboutEditBlackholeWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditBlackholeWindowMsg", &len);
	AboutEditGalaxyWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditGalaxyWindowMsg", &len);
	AboutEditStarWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditStarWindowMsg", &len);
	AboutEditPlanetWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditPlanetWindowMsg", &len);
	AboutEditPlanetShieldWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditPlanetShieldWindowMsg", &len);
	AboutEditPlanetWeaponWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditPlanetWeaponWindowMsg", &len);
	AboutEditShipWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditShipWindowMsg", &len);
	AboutEditShipShieldWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditShipShieldWindowMsg", &len);
	AboutEditShipWeaponWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditShipWeaponWindowMsg", &len);
	AboutEditEngineWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditEngineWindowMsg", &len);
	AboutEditFactoryWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditFactoryWindowMsg", &len);
	AboutEditMineWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditMineWindowMsg", &len);
	AboutEditCompoundWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditCompoundWindowMsg", &len);
	AboutEditElementWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditElementWindowMsg", &len);
	AboutEditWormholeWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditWormholeWindowMsg", &len);
	AboutEditHoleAffectWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditHoleAffectWindowMsg", &len);
	AboutEditSpeciesWindowMsg = (const char *)appResources->FindResource('CSTR', "AboutEditSpeciesWindowMsg", &len);
	AboutUniversalConstantsWindowMsg1 = (const char *)appResources->FindResource('CSTR', "AboutUniversalConstantsWindowMsg1", &len);
	AboutUniversalConstantsWindowMsg2 = (const char *)appResources->FindResource('CSTR', "AboutUniversalConstantsWindowMsg2", &len);
	AboutUniversalConstantsWindowMsg3 = (const char *)appResources->FindResource('CSTR', "AboutUniversalConstantsWindowMsg3", &len);
	AboutUInt32ReqWindow = (const char *)appResources->FindResource('CSTR', "AboutUInt32ReqWindow", &len);
	AboutFontPrefWindowMsg1 = (const char *)appResources->FindResource('CSTR', "AboutFontPrefWindowMsg1", &len);
	AboutFontPrefWindowMsg2 = (const char *)appResources->FindResource('CSTR', "AboutFontPrefWindowMsg2", &len);
	AboutFontPrefWindowMsg3 = (const char *)appResources->FindResource('CSTR', "AboutFontPrefWindowMsg3", &len);
	AboutFontPrefWindowMsg4 = (const char *)appResources->FindResource('CSTR', "AboutFontPrefWindowMsg4", &len);
	AboutFontPrefWindowMsg5 = (const char *)appResources->FindResource('CSTR', "AboutFontPrefWindowMsg5", &len);
	AboutFontPrefWindowMsg6 = (const char *)appResources->FindResource('CSTR', "AboutFontPrefWindowMsg6", &len);
	AboutGutMsg = (const char *)appResources->FindResource('CSTR', "AboutGutMsg", &len);
	AboutBasicColorWindowMsg1 = (const char *)appResources->FindResource('CSTR', "AboutBasicColorWindowMsg1", &len);
	AboutBasicColorWindowMsg2 = (const char *)appResources->FindResource('CSTR', "AboutBasicColorWindowMsg2", &len);
	AboutSpecColorWindow = (const char *)appResources->FindResource('CSTR', "AboutSpecColorWindow", &len);
	AboutFontDisplayWindow = (const char *)appResources->FindResource('CSTR', "AboutFontDisplayWindow", &len);
	DoneStr = (const char *)appResources->FindResource('CSTR', "DoneStr", &len);
	PreviousStr = (const char *)appResources->FindResource('CSTR', "PreviousStr", &len);
	NextStr = (const char *)appResources->FindResource('CSTR', "NextStr", &len);
	NewStr = (const char *)appResources->FindResource('CSTR', "NewStr", &len);
	AddStr = (const char *)appResources->FindResource('CSTR', "AddStr", &len);
	RemoveStr = (const char *)appResources->FindResource('CSTR', "RemoveStr", &len);
	SaveStr = (const char *)appResources->FindResource('CSTR', "SaveStr", &len);
	LoadStr = (const char *)appResources->FindResource('CSTR', "LoadStr", &len);
	ListStr = (const char *)appResources->FindResource('CSTR', "ListStr", &len);
	GetStr = (const char *)appResources->FindResource('CSTR', "GetStr", &len);
	PictureStr = (const char *)appResources->FindResource('CSTR', "PictureStr", &len);
	maxStr = (const char *)appResources->FindResource('CSTR', "maxStr", &len);
	SofLStr = (const char *)appResources->FindResource('CSTR', "SofLStr", &len);
	PropFuelUseStr = (const char *)appResources->FindResource('CSTR', "PropFuelUseStr", &len);
	PropAccelStr = (const char *)appResources->FindResource('CSTR', "PropAccelStr", &len);
	FTLFuelUseStr = (const char *)appResources->FindResource('CSTR', "FTLFuelUseStr", &len);
	FTLAccelStr = (const char *)appResources->FindResource('CSTR', "FTLAccelStr", &len);
	InstFuelUseStr = (const char *)appResources->FindResource('CSTR', "InstFuelUseStr", &len);
	ElectronMassStr = (const char *)appResources->FindResource('CSTR', "ElectronMassStr", &len);
	ProtonMassStr = (const char *)appResources->FindResource('CSTR', "ProtonMassStr", &len);
	NeutronMassStr = (const char *)appResources->FindResource('CSTR', "NeutronMassStr", &len);
	NumGalaxyStr = (const char *)appResources->FindResource('CSTR', "NumGalaxyStr", &len);
	WidthStr = (const char *)appResources->FindResource('CSTR', "WidthStr", &len);
	HeightStr = (const char *)appResources->FindResource('CSTR', "HeightStr", &len);
	DepthStr = (const char *)appResources->FindResource('CSTR', "DepthStr", &len);
	NeedNameToKeep = (const char *)appResources->FindResource('CSTR', "NeedNameToKeep", &len);
	WrongName = (const char *)appResources->FindResource('CSTR', "WrongName", &len);
	FailLockLooper = (const char *)appResources->FindResource('CSTR', "FailLockLooper", &len);
	ReallyQuitApp = (const char *)appResources->FindResource('CSTR', "ReallyQuitApp", &len);
	OpenUC = (const char *)appResources->FindResource('CSTR', "OpenUC", &len);
	OpenUniverse = (const char *)appResources->FindResource('CSTR', "OpenUniverse", &len);
	OpenSpecies = (const char *)appResources->FindResource('CSTR', "OpenSpecies", &len);
	OpenElement = (const char *)appResources->FindResource('CSTR', "OpenElement", &len);
	OpenCompound = (const char *)appResources->FindResource('CSTR', "OpenCompound", &len);
	CaughtFontPrefWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtFontPrefWindowCTOR", &len);
	CaughtPrefPanelWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtPrefPanelWindowCTOR", &len);
	NoPrefPanelWindow = (const char *)appResources->FindResource('CSTR', "NoPrefPanelWindow", &len);
	CaughtBasicColorWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtBasicColorWindowCTOR", &len);
	CaughtSpecificColorWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtSpecificColorWindowCTOR", &len);
	BadSpecColorKindView = (const char *)appResources->FindResource('CSTR', "BadSpecColorKindView", &len);
	BadSpecColorKindHigh = (const char *)appResources->FindResource('CSTR', "BadSpecColorKindHigh", &len);
	BadSpecColorKindLow = (const char *)appResources->FindResource('CSTR', "BadSpecColorKindLow", &len);
	CaughtEditUniverseWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditUniverseWindowCTOR", &len);
	CaughtUniversalConstantsWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtUniversalConstantsWindowCTOR", &len);
	CaughtEditSpeciesWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditSpeciesWindowCTOR", &len);
	CaughtEditHoleAffectsWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditHoleAffectsWindowCTOR", &len);
	CaughtEditWormholeWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditWormholeWindowCTOR", &len);
	CaughtEditBlackholeWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditBlackholeWindowCTOR", &len);
	CaughtEditGalaxyWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditGalaxyWindowCTOR", &len);
	CaughtEditStarWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditStarWindowCTOR", &len);
	CaughtEditPlanetWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditPlanetWindowCTOR", &len);
	CaughtEditPlanetShieldWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditPlanetShieldWindowCTOR", &len);
	CaughtEditPlanetWeaponWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditPlanetWeaponWindowCTOR", &len);
	CaughtEditShipWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditShipWindowCTOR", &len);
	CaughtEditShipShieldWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditShipShieldWindowCTOR", &len);
	CaughtEditShipWeaponWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditShipWeaponWindowCTOR", &len);
	CaughtEditEngineWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditEngineWindowCTOR", &len);
	CaughtEditFactoryWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditFactoryWindowCTOR", &len);
	CaughtEditMineWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditMineWindowCTOR", &len);
	CaughtEditCompoundWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditCompoundWindowCTOR", &len);
	CaughtEditElementWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtEditElementWindowCTOR", &len);
	FailListViewWindow = (const char *)appResources->FindResource('CSTR', "FailListViewWindow", &len);
	CaughtTitleWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtTitleWindowCTOR", &len);
	CaughtUInt32ReqWindowCTOR = (const char *)appResources->FindResource('CSTR', "CaughtUInt32ReqWindowCTOR", &len);
	OnlyOneListView = (const char *)appResources->FindResource('CSTR', "OnlyOneListView", &len);
	UInt32ReqWindowTitle = (const char *)appResources->FindResource('CSTR', "UInt32ReqWindowTitle", &len);
	NameUCStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameUCStrGadgetLable", &len);
	NameUniverseStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameUniverseStrGadgetLable", &len);
	NameSpeciesStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameSpeciesStrGadgetLable", &len);
	NameHoleAffectsStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameHoleAffectsStrGadgetLable", &len);
	NameWormholeStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameWormholeStrGadgetLable", &len);
	NameBlackholeStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameBlackholeStrGadgetLable", &len);
	NameGalaxyStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameGalaxyStrGadgetLable", &len);
	NameStarStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameStarStrGadgetLable", &len);
	NamePlanetStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NamePlanetStrGadgetLable", &len);
	NamePlanetShieldStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NamePlanetShieldStrGadgetLable", &len);
	NamePlanetWeaponStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NamePlanetWeaponStrGadgetLable", &len);
	NameShipStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameShipStrGadgetLable", &len);
	NameShipShieldStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameShipShieldStrGadgetLable", &len);
	NameShipWeaponStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameShipWeaponStrGadgetLable", &len);
	NameEngineStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameEngineStrGadgetLable", &len);
	NameFactoryStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameFactoryStrGadgetLable", &len);
	NameMineStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameMineStrGadgetLable", &len);
	NameCompoundStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameCompoundStrGadgetLable", &len);
	NameElementStrGadgetLable = (const char *)appResources->FindResource('CSTR', "NameElementStrGadgetLable", &len);
	DfltUCButtonLable = (const char *)appResources->FindResource('CSTR', "DfltUCButtonLable", &len);
	DfltSpeciesButtonLable = (const char *)appResources->FindResource('CSTR', "DfltSpeciesButtonLable", &len);
	DfltElementsButtonLable = (const char *)appResources->FindResource('CSTR', "DfltElementsButtonLable", &len);
	DfltCompoundsButtonLable = (const char *)appResources->FindResource('CSTR', "DfltCompoundsButtonLable", &len);
	DsgnUCButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnUCButtonLable", &len);
	DsgnSpeciesButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnSpeciesButtonLable", &len);
	DsgnElementsButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnElementsButtonLable", &len);
	DsgnCompoundsButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnCompoundsButtonLable", &len);
	DsgnMinesButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnMinesButtonLable", &len);
	DsgnFactoriesButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnFactoriesButtonLable", &len);
	DsgnEnginesButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnEnginesButtonLable", &len);
	DsgnShipWeaponsButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnShipWeaponsButtonLable", &len);
	DsgnShipShieldsButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnShipShieldsButtonLable", &len);
	DsgnShipsButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnShipsButtonLable", &len);
	DsgnPlanetWeaponsButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnPlanetWeaponsButtonLable", &len);
	DsgnPlanetShieldsButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnPlanetShieldsButtonLable", &len);
	DsgnPlanetsButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnPlanetsButtonLable", &len);
	DsgnStarsButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnStarsButtonLable", &len);
	DsgnWormholesButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnWormholesButtonLable", &len);
	DsgnBlackholesButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnBlackholesButtonLable", &len);
	DsgnGalaxiesButtonLable = (const char *)appResources->FindResource('CSTR', "DsgnGalaxiesButtonLable", &len);
	LoadUCButtonLable = (const char *)appResources->FindResource('CSTR', "LoadUCButtonLable", &len);
	LoadSpeciesButtonLable = (const char *)appResources->FindResource('CSTR', "LoadSpeciesButtonLable", &len);
	LoadElementsButtonLable = (const char *)appResources->FindResource('CSTR', "LoadElementsButtonLable", &len);
	LoadCompoundsButtonLable = (const char *)appResources->FindResource('CSTR', "LoadCompoundsButtonLable", &len);
	EditUniversalConstantsWindowTitle = (const char *)appResources->FindResource('CSTR', "EditUniversalConstantsWindowTitle", &len);
	FailEditUniversalConstantsWindow = (const char *)appResources->FindResource('CSTR', "FailEditUniversalConstantsWindow", &len);
	EditUniverseWindowTitle = (const char *)appResources->FindResource('CSTR', "EditUniverseWindowTitle", &len);
	FailEditUniverseWindow = (const char *)appResources->FindResource('CSTR', "FailEditUniverseWindow", &len);
	EditSpeciesWindowTitle = (const char *)appResources->FindResource('CSTR', "EditSpeciesWindowTitle", &len);
	FailEditSpeciesWindow = (const char *)appResources->FindResource('CSTR', "FailEditSpeciesWindow", &len);
	EditHoleAffectsWindowTitle = (const char *)appResources->FindResource('CSTR', "EditHoleAffectsWindowTitle", &len);
	FailEditHoleAffectsWindow = (const char *)appResources->FindResource('CSTR', "FailEditHoleAffectsWindow", &len);
	EditWormholeWindowTitle = (const char *)appResources->FindResource('CSTR', "EditWormholeWindowTitle", &len);
	FailEditWormholeWindow = (const char *)appResources->FindResource('CSTR', "FailEditWormholeWindow", &len);
	EditBlackholeWindowTitle = (const char *)appResources->FindResource('CSTR', "EditBlackholeWindowTitle", &len);
	FailEditBlackholeWindow = (const char *)appResources->FindResource('CSTR', "FailEditBlackholeWindow", &len);
	EditGalaxyWindowTitle = (const char *)appResources->FindResource('CSTR', "EditGalaxyWindowTitle", &len);
	FailEditGalaxyWindow = (const char *)appResources->FindResource('CSTR', "FailEditGalaxyWindow", &len);
	EditStarWindowTitle = (const char *)appResources->FindResource('CSTR', "EditStarWindowTitle", &len);
	FailEditStarWindow = (const char *)appResources->FindResource('CSTR', "FailEditStarWindow", &len);
	EditPlanetWindowTitle = (const char *)appResources->FindResource('CSTR', "EditPlanetWindowTitle", &len);
	FailEditPlanetWindow = (const char *)appResources->FindResource('CSTR', "FailEditPlanetWindow", &len);
	EditPlanetShieldWindowTitle = (const char *)appResources->FindResource('CSTR', "EditPlanetShieldWindowTitle", &len);
	FailEditPlanetShieldWindow = (const char *)appResources->FindResource('CSTR', "FailEditPlanetShieldWindow", &len);
	EditPlanetWeaponWindowTitle = (const char *)appResources->FindResource('CSTR', "EditPlanetWeaponWindowTitle", &len);
	FailEditPlanetWeaponWindow = (const char *)appResources->FindResource('CSTR', "FailEditPlanetWeaponWindow", &len);
	EditShipWindowTitle = (const char *)appResources->FindResource('CSTR', "EditShipWindowTitle", &len);
	FailEditShipWindow = (const char *)appResources->FindResource('CSTR', "FailEditShipWindow", &len);
	EditShipShieldWindowTitle = (const char *)appResources->FindResource('CSTR', "EditShipShieldWindowTitle", &len);
	FailEditShipShieldWindow = (const char *)appResources->FindResource('CSTR', "FailEditShipShieldWindow", &len);
	EditShipWeaponWindowTitle = (const char *)appResources->FindResource('CSTR', "EditShipWeaponWindowTitle", &len);
	FailEditShipWeaponWindow = (const char *)appResources->FindResource('CSTR', "FailEditShipWeaponWindow", &len);
	EditEngineWindowTitle = (const char *)appResources->FindResource('CSTR', "EditEngineWindowTitle", &len);
	FailEditEngineWindow = (const char *)appResources->FindResource('CSTR', "FailEditEngineWindow", &len);
	EditFactoryWindowTitle = (const char *)appResources->FindResource('CSTR', "EditFactoryWindowTitle", &len);
	FailEditFactoryWindow = (const char *)appResources->FindResource('CSTR', "FailEditFactoryWindow", &len);
	EditMineWindowTitle = (const char *)appResources->FindResource('CSTR', "EditMineWindowTitle", &len);
	FailEditMineWindow = (const char *)appResources->FindResource('CSTR', "FailEditMineWindow", &len);
	EditCompoundWindowTitle = (const char *)appResources->FindResource('CSTR', "EditCompoundWindowTitle", &len);
	FailEditCompoundWindow = (const char *)appResources->FindResource('CSTR', "FailEditCompoundWindow", &len);
	EditElementWindowTitle = (const char *)appResources->FindResource('CSTR', "EditElementWindowTitle", &len);
	FailEditElementWindow = (const char *)appResources->FindResource('CSTR', "FailEditElementWindow", &len);
	OpenScenario = (const char *)appResources->FindResource('CSTR', "OpenScenario", &len);
	SaveScenario = (const char *)appResources->FindResource('CSTR', "SaveScenario", &len);
	everythingNamed = (const char *)appResources->FindResource('CSTR', "everythingNamed", &len);
	FailFileGetSize = (const char *)appResources->FindResource('CSTR', "FailFileGetSize", &len);
	FailFileWriteSize = (const char *)appResources->FindResource('CSTR', "FailFileWriteSize", &len);
	FailFileInitCheck = (const char *)appResources->FindResource('CSTR', "FailFileInitCheck", &len);
	FailFileFindRef = (const char *)appResources->FindResource('CSTR', "FailFileFindRef", &len);
	FailFileSetTo = (const char *)appResources->FindResource('CSTR', "FailFileSetTo", &len);
	FailFileName = (const char *)appResources->FindResource('CSTR', "FailFileName", &len);
	FailFileDir = (const char *)appResources->FindResource('CSTR', "FailFileDir", &len);
	badFileLength = (const char *)appResources->FindResource('CSTR', "badFileLength", &len);
	badFileNoOpen = (const char *)appResources->FindResource('CSTR', "badFileNoOpen", &len);
	badVersion = (const char *)appResources->FindResource('CSTR', "badVersion", &len);
	wrongKind = (const char *)appResources->FindResource('CSTR', "wrongKind", &len);
	noSave = (const char *)appResources->FindResource('CSTR', "noSave", &len);
	noLoad = (const char *)appResources->FindResource('CSTR', "noLoad", &len);
	badKindRevision = (const char *)appResources->FindResource('CSTR', "badKindRevision", &len);
	badKindVersion = (const char *)appResources->FindResource('CSTR', "badKindVersion", &len);
	noHeader = (const char *)appResources->FindResource('CSTR', "noHeader", &len);
	WarningOKLable = (const char *)appResources->FindResource('CSTR', "WarningOKLable", &len);
	FailMemory = (const char *)appResources->FindResource('CSTR', "FailMemory", &len);
	FailAddItem = (const char *)appResources->FindResource('CSTR', "FailAddItem", &len);
	FailCreateName = (const char *)appResources->FindResource('CSTR', "FailCreateName", &len);
	FailCreateData = (const char *)appResources->FindResource('CSTR', "FailCreateData", &len);
	FailFloatGadget = (const char *)appResources->FindResource('CSTR', "FailFloatGadget", &len);
	FailStarClass = (const char *)appResources->FindResource('CSTR', "FailStarClass", &len);
	FailStringGadget = (const char *)appResources->FindResource('CSTR', "FailStringGadget", &len);
	FailUInt32Gadget = (const char *)appResources->FindResource('CSTR', "FailUInt32Gadget", &len);
	FailUInt32ReqWindow = (const char *)appResources->FindResource('CSTR', "FailUInt32ReqWindow", &len);
	FailWarningWindow = (const char *)appResources->FindResource('CSTR', "FailWarningWindow", &len);
	FailDataList = (const char *)appResources->FindResource('CSTR', "FailDataList", &len);
	FailPtrList = (const char *)appResources->FindResource('CSTR', "FailPtrList", &len);
	FailMergeList = (const char *)appResources->FindResource('CSTR', "FailMergeList", &len);
	FailDataNode = (const char *)appResources->FindResource('CSTR', "FailDataNode", &len);
	FailUIntPtrNode = (const char *)appResources->FindResource('CSTR', "FailUIntPtrNode", &len);
	FailMergeNode = (const char *)appResources->FindResource('CSTR', "FailMergeNode", &len);
	FailMPtrNode = (const char *)appResources->FindResource('CSTR', "FailMPtrNode", &len);
	FailScrollView = (const char *)appResources->FindResource('CSTR', "FailScrollView", &len);
	FailCharString = (const char *)appResources->FindResource('CSTR', "FailCharString", &len);
	FailMyStringDrawer = (const char *)appResources->FindResource('CSTR', "FailMyStringDrawer", &len);
	FailEditWindow = (const char *)appResources->FindResource('CSTR', "FailEditWindow", &len);
	FailName = (const char *)appResources->FindResource('CSTR', "FailName", &len);
	FailMasterList = (const char *)appResources->FindResource('CSTR', "FailMasterList", &len);
	FailDObj = (const char *)appResources->FindResource('CSTR', "FailDObj", &len);
	FailUniverseUnique = (const char *)appResources->FindResource('CSTR', "FailUniverseUnique", &len);
	FailNameUniqueDefault = (const char *)appResources->FindResource('CSTR', "FailNameUniqueDefault", &len);
	FailElementENPUnique = (const char *)appResources->FindResource('CSTR', "FailElementENPUnique", &len);
	FailElementMassUnique = (const char *)appResources->FindResource('CSTR', "FailElementMassUnique", &len);
	FailListView = (const char *)appResources->FindResource('CSTR', "FailListView", &len);
	FailListViewNoFrom = (const char *)appResources->FindResource('CSTR', "FailListViewNoFrom", &len);
	FailListViewNoTo = (const char *)appResources->FindResource('CSTR', "FailListViewNoTo", &len);
	FailListViewNoOf = (const char *)appResources->FindResource('CSTR', "FailListViewNoOf", &len);
	FailCaseDefaultcPtrNode = (const char *)appResources->FindResource('CSTR', "FailCaseDefaultcPtrNode", &len);
	FailCaseDefaultDataList = (const char *)appResources->FindResource('CSTR', "FailCaseDefaultDataList", &len);
	FailCaseDefaultDataNode = (const char *)appResources->FindResource('CSTR', "FailCaseDefaultDataNode", &len);
	FailCaseDefaultuIntPtrNode = (const char *)appResources->FindResource('CSTR', "FailCaseDefaultuIntPtrNode", &len);
	FailCaseDefaultmergeNode = (const char *)appResources->FindResource('CSTR', "FailCaseDefaultmergeNode", &len);
	FailCaseDefaultfPtrNode = (const char *)appResources->FindResource('CSTR', "FailCaseDefaultfPtrNode", &len);
	univXerr = (const char *)appResources->FindResource('CSTR', "univXerr", &len);
	univYerr = (const char *)appResources->FindResource('CSTR', "univYerr", &len);
	univZerr = (const char *)appResources->FindResource('CSTR', "univZerr", &len);
	univWidtherr = (const char *)appResources->FindResource('CSTR', "univWidtherr", &len);
	univHeighterr = (const char *)appResources->FindResource('CSTR', "univHeighterr", &len);
	univDeptherr = (const char *)appResources->FindResource('CSTR', "univDeptherr", &len);
	univSerr = (const char *)appResources->FindResource('CSTR', "univSerr", &len);
	univPerr = (const char *)appResources->FindResource('CSTR', "univPerr", &len);
	univFerr = (const char *)appResources->FindResource('CSTR', "univFerr", &len);
	univPAerr = (const char *)appResources->FindResource('CSTR', "univPAerr", &len);
	univFAerr = (const char *)appResources->FindResource('CSTR', "univFAerr", &len);
	univIerr = (const char *)appResources->FindResource('CSTR', "univIerr", &len);
	univEerr = (const char *)appResources->FindResource('CSTR', "univEerr", &len);
	univNerr = (const char *)appResources->FindResource('CSTR', "univNerr", &len);
	univPRerr = (const char *)appResources->FindResource('CSTR', "univPRerr", &len);
	univNGerr = (const char *)appResources->FindResource('CSTR', "univNGerr", &len);
	IRWerr = (const char *)appResources->FindResource('CSTR', "IRWerr", &len);
	FRWerr = (const char *)appResources->FindResource('CSTR', "FRWerr", &len);
	notOnDataList = (const char *)appResources->FindResource('CSTR', "notOnDataList", &len);
	notOnMergeList = (const char *)appResources->FindResource('CSTR', "notOnMergeList", &len);
	eListElectronErr = (const char *)appResources->FindResource('CSTR', "eListElectronErr", &len);
	eListNeutronErr = (const char *)appResources->FindResource('CSTR', "eListNeutronErr", &len);
	eListProtonErr = (const char *)appResources->FindResource('CSTR', "eListProtonErr", &len);
	SCGVolumeErr = (const char *)appResources->FindResource('CSTR', "SCGVolumeErr", &len);
	SCGVolumePerErr = (const char *)appResources->FindResource('CSTR', "SCGVolumePerErr", &len);
	buildConstantsSaveFail = (const char *)appResources->FindResource('CSTR', "buildConstantsSaveFail", &len);
	buildConstantsLoadFail = (const char *)appResources->FindResource('CSTR', "buildConstantsLoadFail", &len);
	constantsSaveFail = (const char *)appResources->FindResource('CSTR', "constantsSaveFail", &len);
	constantsLoadFail = (const char *)appResources->FindResource('CSTR', "constantsLoadFail", &len);
	smallConstantsSaveFail = (const char *)appResources->FindResource('CSTR', "smallConstantsSaveFail", &len);
	smallConstantsLoadFail = (const char *)appResources->FindResource('CSTR', "smallConstantsLoadFail", &len);
	FailBadSelectValueDoableButPut = (const char *)appResources->FindResource('CSTR', "FailBadSelectValueDoableButPut", &len);
	s2fErr = (const char *)appResources->FindResource('CSTR', "s2fErr", &len);
	galaxyXErr = (const char *)appResources->FindResource('CSTR', "galaxyXErr", &len);
	galaxyYErr = (const char *)appResources->FindResource('CSTR', "galaxyYErr", &len);
	galaxyZErr = (const char *)appResources->FindResource('CSTR', "galaxyZErr", &len);
	wormholeXErr = (const char *)appResources->FindResource('CSTR', "wormholeXErr", &len);
	wormholeYErr = (const char *)appResources->FindResource('CSTR', "wormholeYErr", &len);
	wormholeZErr = (const char *)appResources->FindResource('CSTR', "wormholeZErr", &len);
	blackholeXErr = (const char *)appResources->FindResource('CSTR', "blackholeXErr", &len);
	blackholeYErr = (const char *)appResources->FindResource('CSTR', "blackholeYErr", &len);
	blackholeZErr = (const char *)appResources->FindResource('CSTR', "blackholeZErr", &len);
	planetXErr = (const char *)appResources->FindResource('CSTR', "planetXErr", &len);
	planetYErr = (const char *)appResources->FindResource('CSTR', "planetYErr", &len);
	planetZErr = (const char *)appResources->FindResource('CSTR', "planetZErr", &len);
	starXErr = (const char *)appResources->FindResource('CSTR', "starXErr", &len);
	starYErr = (const char *)appResources->FindResource('CSTR', "starYErr", &len);
	starZErr = (const char *)appResources->FindResource('CSTR', "starZErr", &len);
	selectMaintValue = (const char *)appResources->FindResource('CSTR', "selectMaintValue", &len);
	showMaintValue = (const char *)appResources->FindResource('CSTR', "showMaintValue", &len);
	selectProdValue = (const char *)appResources->FindResource('CSTR', "selectProdValue", &len);
	showProdValue = (const char *)appResources->FindResource('CSTR', "showProdValue", &len);
	selectConsumeValue = (const char *)appResources->FindResource('CSTR', "selectConsumeValue", &len);
	showConsumeValue = (const char *)appResources->FindResource('CSTR', "showConsumeValue", &len);
	primalEStr = (const char *)appResources->FindResource('CSTR', "primalEStr", &len);
	primalCStr = (const char *)appResources->FindResource('CSTR', "primalCStr", &len);
	manuEStr = (const char *)appResources->FindResource('CSTR', "manuEStr", &len);
	manuCStr = (const char *)appResources->FindResource('CSTR', "manuCStr", &len);
	manuMStr = (const char *)appResources->FindResource('CSTR', "manuMStr", &len);
	manuFStr = (const char *)appResources->FindResource('CSTR', "manuFStr", &len);
	manuEngStr = (const char *)appResources->FindResource('CSTR', "manuEngStr", &len);
	manuSStr = (const char *)appResources->FindResource('CSTR', "manuSStr", &len);
	manuSSStr = (const char *)appResources->FindResource('CSTR', "manuSSStr", &len);
	manuSWStr = (const char *)appResources->FindResource('CSTR', "manuSWStr", &len);
	manuPSStr = (const char *)appResources->FindResource('CSTR', "manuPSStr", &len);
	manuPWStr = (const char *)appResources->FindResource('CSTR', "manuPWStr", &len);
	preAlertMsgStr = (const char *)appResources->FindResource('CSTR', "preAlertMsgStr", &len);
	oldEHeaderStr = (const char *)appResources->FindResource('CSTR', "oldEHeaderStr", &len);
	newEHeaderStr = (const char *)appResources->FindResource('CSTR', "newEHeaderStr", &len);
	newCHeaderStr = (const char *)appResources->FindResource('CSTR', "newCHeaderStr", &len);
	oldCHeaderStr = (const char *)appResources->FindResource('CSTR', "oldCHeaderStr", &len);
	numElementsStr = (const char *)appResources->FindResource('CSTR', "numElementsStr", &len);
	numCompoundsStr = (const char *)appResources->FindResource('CSTR', "numCompoundsStr", &len);
	useOldStr = (const char *)appResources->FindResource('CSTR', "useOldStr", &len);
	useNewStr = (const char *)appResources->FindResource('CSTR', "useNewStr", &len);
	numElementalElectrons = (const char *)appResources->FindResource('CSTR', "numElementalElectrons", &len);
	numElementalNeutrons = (const char *)appResources->FindResource('CSTR', "numElementalNeutrons", &len);
	numElementalProtons = (const char *)appResources->FindResource('CSTR', "numElementalProtons", &len);
	numVolumeStr = (const char *)appResources->FindResource('CSTR', "numVolumeStr", &len);
	numVPerStr = (const char *)appResources->FindResource('CSTR', "numVPerStr", &len);
	PreferenceMenuLable = (const char *)appResources->FindResource('CSTR', "PreferenceMenuLable", &len);
	PrefSignature = (const char *)appResources->FindResource('CSTR', "PrefSignature", &len);
	PrefFailInit = (const char *)appResources->FindResource('CSTR', "PrefFailInit", &len);
	PrefFailGetSettings = (const char *)appResources->FindResource('CSTR', "PrefFailGetSettings", &len);
	PrefFailSetSettings = (const char *)appResources->FindResource('CSTR', "PrefFailSetSettings", &len);
	PreferencePanelWindowTitle = (const char *)appResources->FindResource('CSTR', "PreferencePanelWindowTitle", &len);
	PrefsNoSetColorWellHighColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetColorWellHighColor", &len);
	PrefsNoSetolorWellLowColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetolorWellLowColor", &len);
	PrefsNoSetColorWellViewColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetColorWellViewColor", &len);
	PrefsNoSetMyButtonHighColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyButtonHighColor", &len);
	PrefsNoSetMyButtonLowColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyButtonLowColor", &len);
	PrefsNoSetMyButtonViewColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyButtonViewColor", &len);
	PrefsNoSetMyPictureButtonHighColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyPictureButtonHighColor", &len);
	PrefsNoSetMyPictureButtonLowColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyPictureButtonLowColor", &len);
	PrefsNoSetMyPictureButtonViewColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyPictureButtonViewColor", &len);
	PrefsNoSetMyCheckBoxHighColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyCheckBoxHighColor", &len);
	PrefsNoSetMyCheckBoxLowColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyCheckBoxLowColor", &len);
	PrefsNoSetMyCheckBoxViewColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyCheckBoxViewColor", &len);
	PrefsNoSetMyStatusBarHighColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyStatusBarHighColor", &len);
	PrefsNoSetMyStatusBarLowColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyStatusBarLowColor", &len);
	PrefsNoSetMyStatusBarViewColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyStatusBarViewColor", &len);
	PrefsNoSetMyBarColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyBarColor", &len);
	PrefsNoSetMyColorControlHighColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyColorControlHighColor", &len);
	PrefsNoSetMyColorControlLowColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyColorControlLowColor", &len);
	PrefsNoSetMyColorControlViewColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyColorControlViewColor", &len);
	PrefsNoSetMyStringDrawerHighColor  = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyStringDrawerHighColor", &len);
	PrefsNoSetMyStringDrawerLowColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyStringDrawerLowColor", &len);
	PrefsNoSetMyStringDrawerViewColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyStringDrawerViewColor", &len);
	PrefsNoSetMyRadioViewHighColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyRadioViewHighColor", &len);
	PrefsNoSetMyRadioViewLowColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyRadioViewLowColor", &len);
	PrefsNoSetMyRadioViewViewColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyRadioViewViewColor", &len);
	PrefsNoSetMyTextViewHighColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyTextViewHighColor", &len);
	PrefsNoSetMyTextViewLowColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyTextViewLowColor", &len);
	PrefsNoSetMyTextViewViewColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyTextViewViewColor", &len);
	PrefsNoSetUInt32GadgetHighColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetUInt32GadgetHighColor", &len);
	PrefsNoSetUInt32GadgetLowColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetUInt32GadgetLowColor", &len);
	PrefsNoSetUInt32GadgetViewColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetUInt32GadgetViewColor", &len);
	PrefsNoSetFloatGadgetHighColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetFloatGadgetHighColor", &len);
	PrefsNoSetFloatGadgetLowColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetFloatGadgetLowColor", &len);
	PrefsNoSetFloatGadgetViewColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetFloatGadgetViewColor", &len);
	PrefsNoSetHighColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetHighColor", &len);
	PrefsNoSetLowColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetLowColor", &len);
	PrefsNoSetViewColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetViewColor", &len);
	FontPrefWindowTitle = (const char *)appResources->FindResource('CSTR', "FontPrefWindowTitle", &len);
	FontPrefWindowHeading1 = (const char *)appResources->FindResource('CSTR', "FontPrefWindowHeading1", &len);
	BiggerFontButtonLable = (const char *)appResources->FindResource('CSTR', "BiggerFontButtonLable", &len);
	SmallerFontButtonLable = (const char *)appResources->FindResource('CSTR', "SmallerFontButtonLable", &len);
	EnterFontSizeLable = (const char *)appResources->FindResource('CSTR', "EnterFontSizeLable", &len);
	DisplayFontCheckBoxLable = (const char *)appResources->FindResource('CSTR', "DisplayFontCheckBoxLable", &len);
	FontDisplayNotNull = (const char *)appResources->FindResource('CSTR', "FontDisplayNotNull", &len);
	FontDisplayWindowTitle = (const char *)appResources->FindResource('CSTR', "FontDisplayWindowTitle", &len);
	FailFontDisplayWindow = (const char *)appResources->FindResource('CSTR', "FailFontDisplayWindow", &len);
	FailMinFontSize = (const char *)appResources->FindResource('CSTR', "FailMinFontSize", &len);
	FailMaxFontSize = (const char *)appResources->FindResource('CSTR', "FailMaxFontSize", &len);
	PrefsNoSetFont = (const char *)appResources->FindResource('CSTR', "PrefsNoSetFont", &len);
	PrefsNoSetOpenFontDisplay = (const char *)appResources->FindResource('CSTR', "PrefsNoSetOpenFontDisplay", &len);
	PrefsNoSetUseColorWell = (const char *)appResources->FindResource('CSTR', "PrefsNoSetUseColorWell", &len);
	PrefsNoSetUseColorControl = (const char *)appResources->FindResource('CSTR', "PrefsNoSetUseColorControl", &len);
	PrefsNoSaveSet = (const char *)appResources->FindResource('CSTR', "PrefsNoSaveSet", &len);
	PrefPanelWindowHeading1 = (const char *)appResources->FindResource('CSTR', "PrefPanelWindowHeading1", &len);
	PrefPanelFontButtonLable = (const char *)appResources->FindResource('CSTR', "PrefPanelFontButtonLable", &len);
	PrefPanelWindowHeading2 = (const char *)appResources->FindResource('CSTR', "PrefPanelWindowHeading2", &len);
	BarCWLabel = (const char *)appResources->FindResource('CSTR', "BarCWLabel", &len);
	BarCCLabel = (const char *)appResources->FindResource('CSTR', "BarCCLabel", &len);
	PrefsNoSetMyListViewHighColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyListViewHighColor", &len);
	PrefsNoSetMyListViewLowColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyListViewLowColor", &len);
	PrefsNoSetMyListViewViewColor = (const char *)appResources->FindResource('CSTR', "PrefsNoSetMyListViewViewColor", &len);
	FailCreateSemaphore = (const char *)appResources->FindResource('CSTR', "FailCreateSemaphore", &len);
	FailAqSem = (const char *)appResources->FindResource('CSTR', "FailAqSem", &len);
	NoShowWindow = (const char *)appResources->FindResource('CSTR', "NoShowWindow", &len);
	NoShowView = (const char *)appResources->FindResource('CSTR', "NoShowView", &len);
	AppMenuLable = (const char *)appResources->FindResource('CSTR', "AppMenuLable", &len);
	QuitMenuLable = (const char *)appResources->FindResource('CSTR', "QuitMenuLable", &len);
	FileMenuLable = (const char *)appResources->FindResource('CSTR', "FileMenuLable", &len);
	CloseWindow = (const char *)appResources->FindResource('CSTR', "CloseWindow", &len);
	ScreenNotValid = (const char *)appResources->FindResource('CSTR', "ScreenNotValid", &len);
	NotFoundScrollView = (const char *)appResources->FindResource('CSTR', "NotFoundScrollView", &len);
	PrefNoSetGutFrame = (const char *)appResources->FindResource('CSTR', "PrefNoSetGutFrame", &len);
	S2UI32Neg = (const char *)appResources->FindResource('CSTR', "S2UI32Neg", &len);
	S2UI32TooBig = (const char *)appResources->FindResource('CSTR', "S2UI32TooBig", &len);
	S2UI32Invalid = (const char *)appResources->FindResource('CSTR', "S2UI32Invalid", &len);
	BasicColorWindowHeading1 = (const char *)appResources->FindResource('CSTR', "BasicColorWindowHeading1", &len);
	ColorWindowHeading2 = (const char *)appResources->FindResource('CSTR', "ColorWindowHeading2", &len);
	ColorWindowHeading3 = (const char *)appResources->FindResource('CSTR', "ColorWindowHeading3", &len);
	ColorWindowHeading4 = (const char *)appResources->FindResource('CSTR', "ColorWindowHeading4", &len);
	ColorWindowHeading5 = (const char *)appResources->FindResource('CSTR', "ColorWindowHeading5", &len);
	ColorWindowHeading6 = (const char *)appResources->FindResource('CSTR', "ColorWindowHeading6", &len);
	ColorWindowHeading7 = (const char *)appResources->FindResource('CSTR', "ColorWindowHeading7", &len);
	DemoRoNo = (const char *)appResources->FindResource('CSTR', "DemoRoNo", &len);
	RoBadMsg = (const char *)appResources->FindResource('CSTR', "RoBadMsg", &len);
	BarColorTitle = (const char *)appResources->FindResource('CSTR', "BarColorTitle", &len);
	DemoButtonLable = (const char *)appResources->FindResource('CSTR', "DemoButtonLable", &len);
	DemoRadio1Lable = (const char *)appResources->FindResource('CSTR', "DemoRadio1Lable", &len);
	DemoRadio2Lable = (const char *)appResources->FindResource('CSTR', "DemoRadio2Lable", &len);
	DemoRadio3Lable = (const char *)appResources->FindResource('CSTR', "DemoRadio3Lable", &len);
	DemoRadioFailInit = (const char *)appResources->FindResource('CSTR', "DemoRadioFailInit", &len);
	DemoCheckBoxLable = (const char *)appResources->FindResource('CSTR', "DemoCheckBoxLable", &len);
	DemoSTatusBarLeadLable = (const char *)appResources->FindResource('CSTR', "DemoSTatusBarLeadLable", &len);
	DemoSTatusBarTrailLable = (const char *)appResources->FindResource('CSTR', "DemoSTatusBarTrailLable", &len);
	StringGadgetLable = (const char *)appResources->FindResource('CSTR', "StringGadgetLable", &len);
	TextGadgetLable = (const char *)appResources->FindResource('CSTR', "TextGadgetLable", &len);
	ListViewGadgetLable = (const char *)appResources->FindResource('CSTR', "ListViewGadgetLable", &len);
	ListViewSample1 = (const char *)appResources->FindResource('CSTR', "ListViewSample1", &len);
	ListViewSample2 = (const char *)appResources->FindResource('CSTR', "ListViewSample2", &len);
	ListViewSample3 = (const char *)appResources->FindResource('CSTR', "ListViewSample3", &len);
	SelectFromList = (const char *)appResources->FindResource('CSTR', "SelectFromList", &len);
	InvokeFromList = (const char *)appResources->FindResource('CSTR', "InvokeFromList", &len);
	UInt32GadgetLable = (const char *)appResources->FindResource('CSTR', "UInt32GadgetLable", &len);
	FloatGadgetLable = (const char *)appResources->FindResource('CSTR', "FloatGadgetLable", &len);
	DemoRoLable = (const char *)appResources->FindResource('CSTR', "DemoRoLable", &len);
	DemoTextItemText = (const char *)appResources->FindResource('CSTR', "DemoTextItemText", &len);
	BadSpecItemKind = (const char *)appResources->FindResource('CSTR', "BadSpecItemKind", &len);
	BadSpecKindQR = (const char *)appResources->FindResource('CSTR', "BadSpecKindQR", &len);
	BadSpecKindColorSetView = (const char *)appResources->FindResource('CSTR', "BadSpecKindColorSetView", &len);
	BadSpecKindColorSetHigh = (const char *)appResources->FindResource('CSTR', "BadSpecKindColorSetHigh", &len);
	BadSpecKindColorSetLow = (const char *)appResources->FindResource('CSTR', "BadSpecKindColorSetLow", &len);
	DisplayBColorControls = (const char *)appResources->FindResource('CSTR', "DisplayBColorControls", &len);
	DisplayroColourWells = (const char *)appResources->FindResource('CSTR', "DisplayroColourWells", &len);
	BasicColorWindowTitle = (const char *)appResources->FindResource('CSTR', "BasicColorWindowTitle", &len);
	NoBasicColorWindow = (const char *)appResources->FindResource('CSTR', "NoBasicColorWindow", &len);
	NoSpecColorWindow = (const char *)appResources->FindResource('CSTR', "NoSpecColorWindow", &len);
	FailPUMInitFontWindow = (const char *)appResources->FindResource('CSTR', "FailPUMInitFontWindow", &len);
	FailPUMInitEditWindow = (const char *)appResources->FindResource('CSTR', "FailPUMInitEditWindow", &len);
	FailPUMInit = (const char *)appResources->FindResource('CSTR', "FailPUMInit", &len);
	FailRadioInit = (const char *)appResources->FindResource('CSTR', "FailRadioInit", &len);
	hasStr = (const char *)appResources->FindResource('CSTR', "hasStr", &len);
	howManyQStr = (const char *)appResources->FindResource('CSTR', "howManyQStr", &len);
	howManyStr = (const char *)appResources->FindResource('CSTR', "howManyStr", &len);
	howMany4Str = (const char *)appResources->FindResource('CSTR', "howMany4Str", &len);
	fineStr = (const char *)appResources->FindResource('CSTR', "fineStr", &len);
	PUMMinOriginStarClass = (const char *)appResources->FindResource('CSTR', "PUMMinOriginStarClass", &len);
	PUMMinOriginPlanetCharacteristic = (const char *)appResources->FindResource('CSTR', "PUMMinOriginPlanetCharacteristic", &len);
	PUMMinMinHabitableStarClass = (const char *)appResources->FindResource('CSTR', "PUMMinMinHabitableStarClass", &len);
	PUMMinMinHabitablePlanetCharacteristic = (const char *)appResources->FindResource('CSTR', "PUMMinMinHabitablePlanetCharacteristic", &len);
	PUMMinMaxHabitableStarClass = (const char *)appResources->FindResource('CSTR', "PUMMinMaxHabitableStarClass", &len);
	PUMMinMaxHabitablePlanetCharacteristic = (const char *)appResources->FindResource('CSTR', "PUMMinMaxHabitablePlanetCharacteristic", &len);
	PUMMaxOriginStarClass = (const char *)appResources->FindResource('CSTR', "PUMMaxOriginStarClass", &len);
	PUMMaxOriginPlanetCharacteristic = (const char *)appResources->FindResource('CSTR', "PUMMaxOriginPlanetCharacteristic", &len);
	PUMMaxMinHabitableStarClass = (const char *)appResources->FindResource('CSTR', "PUMMaxMinHabitableStarClass", &len);
	PUMMaxMinHabitablePlanetCharacteristic = (const char *)appResources->FindResource('CSTR', "PUMMaxMinHabitablePlanetCharacteristic", &len);
	PUMMaxMaxHabitableStarClass = (const char *)appResources->FindResource('CSTR', "PUMMaxMaxHabitableStarClass", &len);
	PUMMaxMaxHabitablePlanetCharacteristic = (const char *)appResources->FindResource('CSTR', "PUMMaxMaxHabitablePlanetCharacteristic", &len);
	UInt32GadgetMinOriginOrbit = (const char *)appResources->FindResource('CSTR', "UInt32GadgetMinOriginOrbit", &len);
	UInt32GadgetMaxOriginOrbit = (const char *)appResources->FindResource('CSTR', "UInt32GadgetMaxOriginOrbit", &len);
	UInt32GadgetMinMinHabitableOrbit = (const char *)appResources->FindResource('CSTR', "UInt32GadgetMinMinHabitableOrbit", &len);
	UInt32GadgetMinMaxHabitableOrbit = (const char *)appResources->FindResource('CSTR', "UInt32GadgetMinMaxHabitableOrbit", &len);
	UInt32GadgetMaxMinHabitableOrbit = (const char *)appResources->FindResource('CSTR', "UInt32GadgetMaxMinHabitableOrbit", &len);
	UInt32GadgetMaxMaxHabitableOrbit = (const char *)appResources->FindResource('CSTR', "UInt32GadgetMaxMaxHabitableOrbit", &len);
	TViewDescription = (const char *)appResources->FindResource('CSTR', "TViewDescription", &len);
	truncShort = (const char *)appResources->FindResource('CSTR', "trunc2short", &len);
	noCCenabled = (const char *)appResources->FindResource('CSTR', "noCCenabled", &len);
	AddXfailedBuildConstantsSave = (const char *)appResources->FindResource('CSTR', "AddXfailedBuildConstantsSave", &len);
	BMsgFailUnflatten = (const char *)appResources->FindResource('CSTR', "BMsgFailUnflatten", &len);
	NoAdditem = (const char *)appResources->FindResource('CSTR', "NoAdditem", &len);
	failMenu = (const char *)appResources->FindResource('CSTR', "failMenu", &len);
	WarnTitle = (const char *)appResources->FindResource('CSTR', "WarnTitle", &len);
	AntiAliasFont = (const char *)appResources->FindResource('CSTR', "AntiAliasFont", &len);
	EnterBarHeightLable = (const char *)appResources->FindResource('CSTR', "EnterBarHeightLable", &len);
	PrefsNoSetBarHeight = (const char *)appResources->FindResource('CSTR', "PrefsNoSetBarHeight", &len);
	BMsgFindXFailSmallConstantsLoad = (const char *)appResources->FindResource('CSTR', "BMsgFindXFailSmallConstantsLoad", &len);
	BMsgFindXFailUniversalConstantsLoad = (const char *)appResources->FindResource('CSTR', "BMsgFindXFailUniversalConstantsLoad", &len);
	BMsgAddXFailUniversalConstantsSave = (const char *)appResources->FindResource('CSTR', "BMsgAddXFailUniversalConstantsSave", &len);
	BMsgFindXFailStripFileHeader = (const char *)appResources->FindResource('CSTR', "BMsgFindXFailStripFileHeader", &len);
	BMsgFindXFailStripFileHeaderPre = (const char *)appResources->FindResource('CSTR', "BMsgFindXFailStripFileHeaderPre", &len);
	PrefsNoSetAntiAliasFont = (const char *)appResources->FindResource('CSTR', "PrefsNoSetAntiAliasFont", &len);
	BMsgAddXFailPutFileHeader = (const char *)appResources->FindResource('CSTR', "BMsgAddXFailPutFileHeader", &len);
	BMsgAddXFailPutFileHeaderPre = (const char *)appResources->FindResource('CSTR', "BMsgAddXFailPutFileHeaderPre", &len);
	BMsgAddXfailPUMInit = (const char *)appResources->FindResource('CSTR', "BMsgAddXfailPUMInit", &len);
	BMsgAddXFailSmallConstantsSave = (const char *)appResources->FindResource('CSTR', "BMsgAddXFailSmallConstantsSave", &len);
	FindXfailedBuildConstantsLoad = (const char *)appResources->FindResource('CSTR', "FindXfailedBuildConstantsLoad", &len);
	uint32 i = 0;
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingUniverse", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingGalaxy", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingBlackhole", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingWormhole", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingStar", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingPlanet", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingPlanetShield", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingPlanetWeapon", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingShip", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingShipShield", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingShipWeapon", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingEngine", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingFactory", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingMine", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingCompound", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingElement", &len);
	thingStr[i++] = (const char *)appResources->FindResource('CSTR', "thingSpecies", &len);
	thingStr[i] = (const char *)appResources->FindResource('CSTR', "thingUniversalConstants", &len);
	i = 0;
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editUniverse", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editGalaxy", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editBlackhole", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editWormhole", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editStar", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editPlanet", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editPShield", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editPWeapon", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editShip", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editSShield", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editSWeapon", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editEngine", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editFactory", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editMine", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editCompound", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editElement", &len);
	editThe[i++] = (const char *)appResources->FindResource('CSTR', "editSpecies", &len);
	editThe[i] = (const char *)appResources->FindResource('CSTR', "editUConstants", &len);
	i = 0;
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designUniverse", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designGalaxy", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designBlackhole", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designWormhole", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designStar", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designPlanet", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designPlanetShield", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designPlanetWeapon", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designShip", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designShipShield", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designShipWeapon", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designEngine", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designFactory", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designMine", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designCompound", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designElement", &len);
	designThe[i++] = (const char *)appResources->FindResource('CSTR', "designSpecies", &len);
	designThe[i] = (const char *)appResources->FindResource('CSTR', "designUniversalConstants", &len);
	i = 0;
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultUniverse", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultGalaxy", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultBlackhole", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultWormhole", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultStar", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultPlanet", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultPlanetShield", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultPlanetWeapon", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultShip", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultShipShield", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultShipWeapon", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultEngine", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultFactory", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultMine", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultCompound", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultElement", &len);
	defaultThe[i++] = (const char *)appResources->FindResource('CSTR', "defaultSpecies", &len);
	defaultThe[i] = (const char *)appResources->FindResource('CSTR', "defaultUniversalConstants", &len);
	i = 0;
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreateUniverse", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreateGalaxy", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreateBlackhole", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreateWormhole", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreateStar", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreatePlanet", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreatePlanetShield", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreatePlanetWeapon", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreateShip", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreateShipShield", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreateShipWeapon", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreateEngine", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreateFactory", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreateMine", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreateCompound", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreateElement", &len);
	FailCreate[i++] = (const char *)appResources->FindResource('CSTR', "FailCreateSpecies", &len);
	FailCreate[i] = (const char *)appResources->FindResource('CSTR', "FailCreateUniversalConstants", &len);
	i = 0;
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueUniverse", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueGalaxy", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueBlackhole", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueWormhole", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueStar", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniquePlanet", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniquePlanetShield", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniquePlanetWeapon", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueShip", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueShipShield", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueShipWeapon", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueEngine", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueFactory", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueMine", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueCompound", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueElement", &len);
	FailNameUnique[i++] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueSpecies", &len);
	FailNameUnique[i] = (const char *)appResources->FindResource('CSTR', "FailNameUniqueUniversalConstants", &len);
	i = 0;
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSaveUniverse", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSaveGalaxy", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSaveBlackhole", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSaveWormhole", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSaveStar", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSavePlanet", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSavePlanetShield", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSavePlanetWeapon", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSaveShip", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSaveShipShield", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSaveShipWeapon", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSaveEngine", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSaveFactory", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSaveMine", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSaveCompound", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSaveElement", &len);
	nothingToSave[i++] = (const char *)appResources->FindResource('CSTR', "nothingToSaveSpecies", &len);
	nothingToSave[i] = (const char *)appResources->FindResource('CSTR', "nothingToSaveUniversalConstants", &len);
	i = 0;
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleUniverse", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleGalaxy", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleBlackhole", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleWormhole", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleStar", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitlePlanet", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitlePlanetShield", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitlePlanetWeapon", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleShip", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleShipShield", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleShipWeapon", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleEngine", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleFactory", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleMine", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleCompound", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleElement", &len);
	getSomeWindowTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleSpecies", &len);
	getSomeWindowTitleStr[i] = (const char *)appResources->FindResource('CSTR', "getSomeWinTitleUniversalConstants", &len);
	i = 0;
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitleUniverse", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitleGalaxy", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitleBlackhole", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitleWormhole", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitleStar", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitlePlanet", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitlePlanetShield", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitlePlanetWeapon", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitleShip", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitleShipShield", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitleShipWeapon", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitleEngine", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitleFactory", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitleMine", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitleCompound", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitleElement", &len);
	getSomeTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "getSomeTitleSpecies", &len);
	getSomeTitleStr[i] = (const char *)appResources->FindResource('CSTR', "getSomeTitleStrUniversalConstants", &len);
	i = 0;
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofUniverse", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofGalaxy", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofBlackhole", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofWormhole", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofStar", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofPlanet", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofPlanetShield", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofPlanetWeapon", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofShip", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofShipShield", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofShipWeapon", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofEngine", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofFactory", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofMine", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofCompound", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofElement", &len);
	ofTheStr[i++] = (const char *)appResources->FindResource('CSTR', "ofTheofSpecies", &len);
	ofTheStr[i] = (const char *)appResources->FindResource('CSTR', "ofTheofUniversalConstants", &len);
	i = 0;
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypeUniverse", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypeGalaxy", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypeBlackhole", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypeWormhole", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypeStar", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypePlanet", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypePlanetShield", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypePlanetWeapon", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypeShip", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypeShipShield", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypeShipWeapon", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypeEngine", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypeFactory", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypeMine", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypeCompound", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypeElement", &len);
	howManyType[i++] = (const char *)appResources->FindResource('CSTR', "howManyTypeSpecies", &len);
	howManyType[i] = (const char *)appResources->FindResource('CSTR', "howManyTypeUniversalConstants", &len);
	i = 0;
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitleUniverse", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitleGalaxy", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitleBlackhole", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitleWormhole", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitleStar", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitlePlanet", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitlePlanetShield", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitlePlanetWeapon", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitleShip", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitleShipShield", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitleShipWeapon", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitleEngine", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitleFactory", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitleMine", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitleCompound", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitleElement", &len);
	sstWindowTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstWinTitleSpecies", &len);
	sstWindowTitle[i] = (const char *)appResources->FindResource('CSTR', "sstWinTitleUniversal Constants", &len);
	i = 0;
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitleUniverse", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitleGalaxy", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitleBlackhole", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitleWormhole", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitleStar", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitlePlanet", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitlePlanetShield", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitlePlanetWeapon", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitleShip", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitleShipShield", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitleShipWeapon", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitleEngine", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitleFactory", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitleMine", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitleCompound", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitleElement", &len);
	sstTitle[i++] = (const char *)appResources->FindResource('CSTR', "sstTitleSpecies", &len);
	sstTitle[i] = (const char *)appResources->FindResource('CSTR', "sstTitleUniversalConstants", &len);
	i = 0;
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitleUniverse", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitleGalaxy", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitleBlackhole", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitleWormhole", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitleStar", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitlePlanet", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitlePlanetShield", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitlePlanetWeapon", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitleShip", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitleShipShield", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitleShipWeapon", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitleEngine", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitleFactory", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitleMine", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitleCompound", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitleElement", &len);
	lvwts[i++] = (const char *)appResources->FindResource('CSTR', "lvWinTitleSpecies", &len);
	lvwts[i] = (const char *)appResources->FindResource('CSTR', "lvWinTitleUniversal Constants", &len);
	i = 0;
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitleUniverse", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitleGalaxy", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitleBlackhole", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitleWormhole", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitleStar", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitlePlanet", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitlePlanetShield", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitlePlanetWeapon", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitleShip", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitleShipShield", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitleShipWeapon", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitleEngine", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitleFactory", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitleMine", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitleCompound", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitleElement", &len);
	lvTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lvwTitleSpecies", &len);
	lvTitleStr[i] = (const char *)appResources->FindResource('CSTR', "lvwTitleUniversalConstants", &len);
	i = 0;
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassODwarf", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassOGiant", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassOSuperGiant", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassBDwarf", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassBGiant", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassBSuperGiant", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassADwarf", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassAGiant", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassASuperGiant", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassFDwarf", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassFGiant", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassFSuperGiant", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassGDwarf", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassGGiant", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassGSuperGiant", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassKDwarf", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassKGiant", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassKSuperGiant", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassMDwarf", &len);
	starClassStr[i++] = (const char *)appResources->FindResource('CSTR', "starClassMGiant", &len);
	starClassStr[i] = (const char *)appResources->FindResource('CSTR', "starClassMSuperGiant", &len);
	i = 0;
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrUniverse", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrGalaxy", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrBlackhole", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrWormhole", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrStar", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrPlanet", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrPlanet", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrPlanet", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrShip", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrShip", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrShip", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrEngine", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrFactory", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrMine", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrCompound", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrElement", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrSpecies", &len);
	kindStr[i++] = (const char *)appResources->FindResource('CSTR', "kindStrUniversalConstants", &len);
	kindStr[i] = (const char *)appResources->FindResource('CSTR', "kindStrSave", &len);
	i = 0;
	lvwTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lccpWindowTitleButtonCP", &len);
	lvwTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lccpWindowTitlePictureCP", &len);
	lvwTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lccpWindowTitleRadioButtonCP", &len);
	lvwTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lccpWindowTitleCheckBoxCP", &len);
	lvwTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lccpWindowTitleStatusBarCP", &len);
	lvwTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lccpWindowTitleColorControlCP", &len);
	lvwTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lccpWindowTitleTextviewCP", &len);
	lvwTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lccpWindowTitleUInt32GadgetCP", &len);
	lvwTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lccpWindowTitleString GadgetCP", &len);
	lvwTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lccpWindowTitleroColourColorWellCP", &len);
	lvwTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lccpWindowTitleStringDrawerCP", &len);
	lvwTitleStr[i++] = (const char *)appResources->FindResource('CSTR', "lccpWindowTitleListviewCP", &len);
	lvwTitleStr[i] = (const char *)appResources->FindResource('CSTR', "lccpWindowTitleFloatGadgetCP", &len);
	i = 0;
	buttonLabels[i++] = (const char *)appResources->FindResource('CSTR', "buttonLabelsUnderlyingview", &len);
	buttonLabels[i++] = (const char *)appResources->FindResource('CSTR', "buttonLabelsButton", &len);
	buttonLabels[i++] = (const char *)appResources->FindResource('CSTR', "buttonLabelsPictureButton", &len);
	buttonLabels[i++] = (const char *)appResources->FindResource('CSTR', "buttonLabelsRadioButtons", &len);
	buttonLabels[i++] = (const char *)appResources->FindResource('CSTR', "buttonLabelsCheckBox", &len);
	buttonLabels[i++] = (const char *)appResources->FindResource('CSTR', "buttonLabelsStatusBar", &len);
	buttonLabels[i++] = (const char *)appResources->FindResource('CSTR', "buttonLabelsColorControl", &len);
	buttonLabels[i++] = (const char *)appResources->FindResource('CSTR', "buttonLabelsText View", &len);
	buttonLabels[i++] = (const char *)appResources->FindResource('CSTR', "buttonLabelsUInt32Gadget", &len);
	buttonLabels[i++] = (const char *)appResources->FindResource('CSTR', "buttonLabelsStringGadget", &len);
	buttonLabels[i++] = (const char *)appResources->FindResource('CSTR', "buttonLabelsroColourColorWell", &len);
	buttonLabels[i++] = (const char *)appResources->FindResource('CSTR', "buttonLabelsStringDraw", &len);
	buttonLabels[i++] = (const char *)appResources->FindResource('CSTR', "buttonLabelsListView", &len);
	buttonLabels[i] = (const char *)appResources->FindResource('CSTR', "buttonLabelsFloatGadget", &len);
}//end


void
EmptyGlobalsFromResources(	void)
{
	free ((char *)VerifyCancel);
	free ((char *)AddXfailedBuildConstantsSave);
	free ((char *)FindXfailedBuildConstantsLoad);
	free ((char *)BMsgFailUnflatten);
	free ((char *)BMsgAddXFailSmallConstantsSave);
	free ((char *)AntiAliasFont);
	free ((char *)BMsgFindXFailStripFileHeader);
	free ((char *)BMsgAddXFailPutFileHeaderPre);
	free ((char *)BMsgAddXFailPutFileHeader);
	free ((char *)BMsgFindXFailStripFileHeaderPre);
	free ((char *)NoAdditem);
	free ((char *)WarnTitle);
	free ((char *)failMenu);
	free ((char *)PrefsNoSetAntiAliasFont);
	free ((char *)EnterBarHeightLable);
	free ((char *)BMsgAddXFailUniversalConstantsSave);
	free ((char *)BMsgFindXFailUniversalConstantsLoad);
	free ((char *)PrefsNoSetBarHeight);
	free ((char *)BMsgAddXfailPUMInit);
	free ((char *)VerifyDoNot);
	free ((char *)cIDMsg);
	free ((char *)AppSignature);
	free ((char *)VerifyTitle);
	free ((char *)VerifyDo);
	free ((char *)TitleWindowTitle);
	free ((char *)FailTitleWindow);
	free ((char *)FailCreateAll);
	free ((char *)classGadgetLabelStr);
	free ((char *)MinOriginStarClassText);
	free ((char *)MaxOriginStarClassText);
	free ((char *)ProgramName);
	free ((char *)ProgramNameSubTitle);
	free ((char *)CreateNewLable);
	free ((char *)LoadPreviousLable);
	free ((char *)SaveLable);
	free ((char *)RealLable);
	free ((char *)AboutMenuLable);
	free ((char *)FontFamilyPUMLabel);
	free ((char *)FontStylePUMLabel);
	free ((char *)AboutPrefPanelWindow);
	free ((char *)AboutTitleWindowMsg1);
	free ((char *)AboutTitleWindowMsg2);
	free ((char *)AboutListViewWindow);
	free ((char *)AboutEditUniverseWindowMsg);
	free ((char *)AboutEditBlackholeWindowMsg);
	free ((char *)AboutEditGalaxyWindowMsg);
	free ((char *)AboutEditStarWindowMsg);
	free ((char *)AboutEditPlanetWindowMsg);
	free ((char *)AboutEditPlanetShieldWindowMsg);
	free ((char *)AboutEditPlanetWeaponWindowMsg);
	free ((char *)AboutEditShipWindowMsg);
	free ((char *)AboutEditShipShieldWindowMsg);
	free ((char *)AboutEditShipWeaponWindowMsg);
	free ((char *)AboutEditEngineWindowMsg);
	free ((char *)AboutEditFactoryWindowMsg);
	free ((char *)AboutEditMineWindowMsg);
	free ((char *)AboutEditCompoundWindowMsg);
	free ((char *)AboutEditElementWindowMsg);
	free ((char *)AboutEditWormholeWindowMsg);
	free ((char *)AboutEditHoleAffectWindowMsg);
	free ((char *)AboutEditSpeciesWindowMsg);
	free ((char *)AboutUniversalConstantsWindowMsg1);
	free ((char *)AboutUniversalConstantsWindowMsg2);
	free ((char *)AboutUniversalConstantsWindowMsg3);
	free ((char *)AboutUInt32ReqWindow);
	free ((char *)AboutFontPrefWindowMsg1);
	free ((char *)AboutFontPrefWindowMsg2);
	free ((char *)AboutFontPrefWindowMsg3);
	free ((char *)AboutFontPrefWindowMsg4);
	free ((char *)AboutFontPrefWindowMsg5);
	free ((char *)AboutFontPrefWindowMsg6);
	free ((char *)AboutGutMsg);
	free ((char *)AboutBasicColorWindowMsg1);
	free ((char *)AboutBasicColorWindowMsg2);
	free ((char *)AboutSpecColorWindow);
	free ((char *)AboutFontDisplayWindow);
	free ((char *)DoneStr);
	free ((char *)PreviousStr);
	free ((char *)NextStr);
	free ((char *)NewStr);
	free ((char *)AddStr);
	free ((char *)RemoveStr);
	free ((char *)SaveStr);
	free ((char *)LoadStr);
	free ((char *)ListStr);
	free ((char *)GetStr);
	free ((char *)PictureStr);
	free ((char *)maxStr);
	free ((char *)SofLStr);
	free ((char *)PropFuelUseStr);
	free ((char *)PropAccelStr);
	free ((char *)FTLFuelUseStr);
	free ((char *)FTLAccelStr);
	free ((char *)InstFuelUseStr);
	free ((char *)ElectronMassStr);
	free ((char *)ProtonMassStr);
	free ((char *)NeutronMassStr);
	free ((char *)NumGalaxyStr);
	free ((char *)WidthStr);
	free ((char *)HeightStr);
	free ((char *)DepthStr);
	free ((char *)NeedNameToKeep);
	free ((char *)WrongName);
	free ((char *)FailLockLooper);
	free ((char *)ReallyQuitApp);
	free ((char *)OpenUC);
	free ((char *)OpenUniverse);
	free ((char *)OpenSpecies);
	free ((char *)OpenElement);
	free ((char *)OpenCompound);
	free ((char *)CaughtFontPrefWindowCTOR);
	free ((char *)CaughtPrefPanelWindowCTOR);
	free ((char *)NoPrefPanelWindow);
	free ((char *)CaughtBasicColorWindowCTOR);
	free ((char *)CaughtSpecificColorWindowCTOR);
	free ((char *)BadSpecColorKindView);
	free ((char *)BadSpecColorKindHigh);
	free ((char *)BadSpecColorKindLow);
	free ((char *)CaughtEditUniverseWindowCTOR);
	free ((char *)CaughtUniversalConstantsWindowCTOR);
	free ((char *)CaughtEditSpeciesWindowCTOR);
	free ((char *)CaughtEditHoleAffectsWindowCTOR);
	free ((char *)CaughtEditWormholeWindowCTOR);
	free ((char *)CaughtEditBlackholeWindowCTOR);
	free ((char *)CaughtEditGalaxyWindowCTOR);
	free ((char *)CaughtEditStarWindowCTOR);
	free ((char *)CaughtEditPlanetWindowCTOR);
	free ((char *)CaughtEditPlanetShieldWindowCTOR);
	free ((char *)CaughtEditPlanetWeaponWindowCTOR);
	free ((char *)CaughtEditShipWindowCTOR);
	free ((char *)CaughtEditShipShieldWindowCTOR);
	free ((char *)CaughtEditShipWeaponWindowCTOR);
	free ((char *)CaughtEditEngineWindowCTOR);
	free ((char *)CaughtEditFactoryWindowCTOR);
	free ((char *)CaughtEditMineWindowCTOR);
	free ((char *)CaughtEditCompoundWindowCTOR);
	free ((char *)CaughtEditElementWindowCTOR);
	free ((char *)FailListViewWindow);
	free ((char *)CaughtTitleWindowCTOR);
	free ((char *)CaughtUInt32ReqWindowCTOR);
	free ((char *)OnlyOneListView);
	free ((char *)UInt32ReqWindowTitle);
	free ((char *)NameUCStrGadgetLable);
	free ((char *)NameUniverseStrGadgetLable);
	free ((char *)NameSpeciesStrGadgetLable);
	free ((char *)NameHoleAffectsStrGadgetLable);
	free ((char *)NameWormholeStrGadgetLable);
	free ((char *)NameBlackholeStrGadgetLable);
	free ((char *)NameGalaxyStrGadgetLable);
	free ((char *)NameStarStrGadgetLable);
	free ((char *)NamePlanetStrGadgetLable);
	free ((char *)NamePlanetShieldStrGadgetLable);
	free ((char *)NamePlanetWeaponStrGadgetLable);
	free ((char *)NameShipStrGadgetLable);
	free ((char *)NameShipShieldStrGadgetLable);
	free ((char *)NameShipWeaponStrGadgetLable);
	free ((char *)NameEngineStrGadgetLable);
	free ((char *)NameFactoryStrGadgetLable);
	free ((char *)NameMineStrGadgetLable);
	free ((char *)NameCompoundStrGadgetLable);
	free ((char *)NameElementStrGadgetLable);
	free ((char *)DfltUCButtonLable);
	free ((char *)DfltSpeciesButtonLable);
	free ((char *)DfltElementsButtonLable);
	free ((char *)DfltCompoundsButtonLable);
	free ((char *)DsgnUCButtonLable);
	free ((char *)DsgnSpeciesButtonLable);
	free ((char *)DsgnElementsButtonLable);
	free ((char *)DsgnCompoundsButtonLable);
	free ((char *)DsgnMinesButtonLable);
	free ((char *)DsgnFactoriesButtonLable);
	free ((char *)DsgnEnginesButtonLable);
	free ((char *)DsgnShipWeaponsButtonLable);
	free ((char *)DsgnShipShieldsButtonLable);
	free ((char *)DsgnShipsButtonLable);
	free ((char *)DsgnPlanetWeaponsButtonLable);
	free ((char *)DsgnPlanetShieldsButtonLable);
	free ((char *)DsgnPlanetsButtonLable);
	free ((char *)DsgnStarsButtonLable);
	free ((char *)DsgnWormholesButtonLable);
	free ((char *)DsgnBlackholesButtonLable);
	free ((char *)DsgnGalaxiesButtonLable);
	free ((char *)LoadUCButtonLable);
	free ((char *)LoadSpeciesButtonLable);
	free ((char *)LoadElementsButtonLable);
	free ((char *)LoadCompoundsButtonLable);
	free ((char *)EditUniversalConstantsWindowTitle);
	free ((char *)FailEditUniversalConstantsWindow);
	free ((char *)EditUniverseWindowTitle);
	free ((char *)FailEditUniverseWindow);
	free ((char *)EditSpeciesWindowTitle);
	free ((char *)FailEditSpeciesWindow);
	free ((char *)EditHoleAffectsWindowTitle);
	free ((char *)FailEditHoleAffectsWindow);
	free ((char *)EditWormholeWindowTitle);
	free ((char *)FailEditWormholeWindow);
	free ((char *)EditBlackholeWindowTitle);
	free ((char *)FailEditBlackholeWindow);
	free ((char *)EditGalaxyWindowTitle);
	free ((char *)FailEditGalaxyWindow);
	free ((char *)EditStarWindowTitle);
	free ((char *)FailEditStarWindow);
	free ((char *)EditPlanetWindowTitle);
	free ((char *)FailEditPlanetWindow);
	free ((char *)EditPlanetShieldWindowTitle);
	free ((char *)FailEditPlanetShieldWindow);
	free ((char *)EditPlanetWeaponWindowTitle);
	free ((char *)FailEditPlanetWeaponWindow);
	free ((char *)EditShipWindowTitle);
	free ((char *)FailEditShipWindow);
	free ((char *)EditShipShieldWindowTitle);
	free ((char *)FailEditShipShieldWindow);
	free ((char *)EditShipWeaponWindowTitle);
	free ((char *)FailEditShipWeaponWindow);
	free ((char *)EditEngineWindowTitle);
	free ((char *)FailEditEngineWindow);
	free ((char *)EditFactoryWindowTitle);
	free ((char *)FailEditFactoryWindow);
	free ((char *)EditMineWindowTitle);
	free ((char *)FailEditMineWindow);
	free ((char *)EditCompoundWindowTitle);
	free ((char *)FailEditCompoundWindow);
	free ((char *)EditElementWindowTitle);
	free ((char *)FailEditElementWindow);
	free ((char *)OpenScenario);
	free ((char *)SaveScenario);
	free ((char *)everythingNamed);
	free ((char *)FailFileGetSize);
	free ((char *)FailFileWriteSize);
	free ((char *)FailFileInitCheck);
	free ((char *)FailFileFindRef);
	free ((char *)FailFileSetTo);
	free ((char *)FailFileName);
	free ((char *)FailFileDir);
	free ((char *)badFileLength);
	free ((char *)badFileNoOpen);
	free ((char *)badVersion);
	free ((char *)wrongKind);
	free ((char *)noSave);
	free ((char *)noLoad);
 	free ((char *)badKindRevision);
	free ((char *)badKindVersion);
	free ((char *)noHeader);
	free ((char *)WarningOKLable);
	free ((char *)FailMemory);
	free ((char *)FailAddItem);
	free ((char *)FailCreateName);
	free ((char *)FailCreateData);
	free ((char *)FailFloatGadget);
	free ((char *)FailStarClass);
	free ((char *)FailStringGadget);
	free ((char *)FailUInt32Gadget);
	free ((char *)FailUInt32ReqWindow);
	free ((char *)FailWarningWindow);
	free ((char *)FailDataList);
	free ((char *)FailPtrList);
	free ((char *)FailMergeList);
	free ((char *)FailDataNode);
	free ((char *)FailUIntPtrNode);
	free ((char *)FailMergeNode);
	free ((char *)FailMPtrNode);
	free ((char *)FailScrollView);
	free ((char *)FailCharString);
	free ((char *)FailMyStringDrawer);
	free ((char *)FailEditWindow);
	free ((char *)FailName);
	free ((char *)FailMasterList);
	free ((char *)FailDObj);
	free ((char *)FailUniverseUnique);
	free ((char *)FailNameUniqueDefault);
	free ((char *)FailElementENPUnique);
	free ((char *)FailElementMassUnique);
	free ((char *)FailListView);
	free ((char *)FailListViewNoFrom);
	free ((char *)FailListViewNoTo);
	free ((char *)FailListViewNoOf);
	free ((char *)FailCaseDefaultcPtrNode);
	free ((char *)FailCaseDefaultDataList);
	free ((char *)FailCaseDefaultDataNode);
	free ((char *)FailCaseDefaultuIntPtrNode);
	free ((char *)FailCaseDefaultmergeNode);
	free ((char *)FailCaseDefaultfPtrNode);
	free ((char *)univXerr);
	free ((char *)univYerr);
	free ((char *)univZerr);
	free ((char *)univWidtherr);
	free ((char *)univHeighterr);
	free ((char *)univDeptherr);
	free ((char *)univSerr);
	free ((char *)univPerr);
	free ((char *)univFerr);
	free ((char *)univPAerr);
	free ((char *)univFAerr);
	free ((char *)univIerr);
	free ((char *)univEerr);
	free ((char *)univNerr);
	free ((char *)univPRerr);
	free ((char *)univNGerr);
	free ((char *)IRWerr);
	free ((char *)FRWerr);
	free ((char *)notOnDataList);
	free ((char *)notOnMergeList);
	free ((char *)eListElectronErr);
	free ((char *)eListNeutronErr);
	free ((char *)eListProtonErr);
	free ((char *)SCGVolumeErr);
	free ((char *)SCGVolumePerErr);
	free ((char *)buildConstantsSaveFail);
	free ((char *)buildConstantsLoadFail);
	free ((char *)constantsSaveFail);
	free ((char *)constantsLoadFail);
	free ((char *)smallConstantsSaveFail);
	free ((char *)smallConstantsLoadFail);
	free ((char *)FailBadSelectValueDoableButPut);
	free ((char *)s2fErr);
	free ((char *)galaxyXErr);
	free ((char *)galaxyYErr);
	free ((char *)galaxyZErr);
	free ((char *)wormholeXErr);
	free ((char *)wormholeYErr);
	free ((char *)wormholeZErr);
	free ((char *)blackholeXErr);
	free ((char *)blackholeYErr);
	free ((char *)blackholeZErr);
	free ((char *)planetXErr);
	free ((char *)planetYErr);
	free ((char *)planetZErr);
	free ((char *)starXErr);
	free ((char *)starYErr);
	free ((char *)starZErr);
	free ((char *)selectMaintValue);
	free ((char *)showMaintValue);
	free ((char *)selectProdValue);
	free ((char *)showProdValue);
	free ((char *)selectConsumeValue);
	free ((char *)showConsumeValue);
	free ((char *)primalEStr);
	free ((char *)primalCStr);
	free ((char *)manuEStr);
	free ((char *)manuCStr);
	free ((char *)manuMStr);
	free ((char *)manuFStr);
	free ((char *)manuEngStr);
	free ((char *)manuSStr);
	free ((char *)manuSSStr);
	free ((char *)manuSWStr);
	free ((char *)manuPSStr);
	free ((char *)manuPWStr);
	free ((char *)preAlertMsgStr);
	free ((char *)oldEHeaderStr);
	free ((char *)newEHeaderStr);
	free ((char *)newCHeaderStr);
	free ((char *)oldCHeaderStr);
	free ((char *)numElementsStr);
	free ((char *)numCompoundsStr);
	free ((char *)useOldStr);
	free ((char *)useNewStr);
	free ((char *)numElementalElectrons);
	free ((char *)numElementalNeutrons);
	free ((char *)numElementalProtons);
	free ((char *)numVolumeStr);
	free ((char *)numVPerStr);
	free ((char *)PreferenceMenuLable);
	free ((char *)PrefSignature);
	free ((char *)PrefFailInit);
	free ((char *)PrefFailGetSettings);
	free ((char *)PrefFailSetSettings);
	free ((char *)PreferencePanelWindowTitle);
	free ((char *)PrefsNoSetColorWellHighColor);
	free ((char *)PrefsNoSetolorWellLowColor);
	free ((char *)PrefsNoSetColorWellViewColor);
	free ((char *)PrefsNoSetMyButtonHighColor);
	free ((char *)PrefsNoSetMyButtonLowColor);
	free ((char *)PrefsNoSetMyButtonViewColor);
	free ((char *)PrefsNoSetMyPictureButtonHighColor);
	free ((char *)PrefsNoSetMyPictureButtonLowColor);
	free ((char *)PrefsNoSetMyPictureButtonViewColor);
	free ((char *)PrefsNoSetMyCheckBoxHighColor);
	free ((char *)PrefsNoSetMyCheckBoxLowColor);
	free ((char *)PrefsNoSetMyCheckBoxViewColor);
	free ((char *)PrefsNoSetMyStatusBarHighColor);
	free ((char *)PrefsNoSetMyStatusBarLowColor);
	free ((char *)PrefsNoSetMyStatusBarViewColor);
	free ((char *)PrefsNoSetMyBarColor);
	free ((char *)PrefsNoSetMyColorControlHighColor);
	free ((char *)PrefsNoSetMyColorControlLowColor);
	free ((char *)PrefsNoSetMyColorControlViewColor);
	free ((char *)PrefsNoSetMyStringDrawerHighColor);
	free ((char *)PrefsNoSetMyStringDrawerLowColor);
	free ((char *)PrefsNoSetMyStringDrawerViewColor);
	free ((char *)PrefsNoSetMyRadioViewHighColor);
	free ((char *)PrefsNoSetMyRadioViewLowColor);
	free ((char *)PrefsNoSetMyRadioViewViewColor);
	free ((char *)PrefsNoSetMyTextViewHighColor);
	free ((char *)PrefsNoSetMyTextViewLowColor);
	free ((char *)PrefsNoSetMyTextViewViewColor);
	free ((char *)PrefsNoSetUInt32GadgetHighColor);
	free ((char *)PrefsNoSetUInt32GadgetLowColor);
	free ((char *)PrefsNoSetUInt32GadgetViewColor);
	free ((char *)PrefsNoSetFloatGadgetHighColor);
	free ((char *)PrefsNoSetFloatGadgetLowColor);
	free ((char *)PrefsNoSetFloatGadgetViewColor);
	free ((char *)PrefsNoSetHighColor);
	free ((char *)PrefsNoSetLowColor);
	free ((char *)PrefsNoSetViewColor);
	free ((char *)FontPrefWindowTitle);
	free ((char *)FontPrefWindowHeading1);
	free ((char *)BiggerFontButtonLable);
	free ((char *)SmallerFontButtonLable);
	free ((char *)EnterFontSizeLable);
	free ((char *)DisplayFontCheckBoxLable);
	free ((char *)FontDisplayNotNull);
	free ((char *)FontDisplayWindowTitle);
	free ((char *)FailFontDisplayWindow);
	free ((char *)FailMinFontSize);
	free ((char *)FailMaxFontSize);
	free ((char *)PrefsNoSetFont);
	free ((char *)PrefsNoSetOpenFontDisplay);
	free ((char *)PrefsNoSetUseColorWell);
	free ((char *)PrefsNoSetUseColorControl);
	free ((char *)PrefsNoSaveSet);
	free ((char *)PrefPanelWindowHeading1);
	free ((char *)PrefPanelFontButtonLable);
	free ((char *)PrefPanelWindowHeading2);
	free ((char *)BarCWLabel);
	free ((char *)BarCCLabel);
	free ((char *)PrefsNoSetMyListViewHighColor);
	free ((char *)PrefsNoSetMyListViewLowColor);
	free ((char *)PrefsNoSetMyListViewViewColor);
	free ((char *)FailCreateSemaphore);
	free ((char *)FailAqSem);
	free ((char *)NoShowWindow);
	free ((char *)NoShowView);
	free ((char *)AppMenuLable);
	free ((char *)QuitMenuLable);
	free ((char *)FileMenuLable);
	free ((char *)CloseWindow);
	free ((char *)ScreenNotValid);
	free ((char *)NotFoundScrollView);
	free ((char *)PrefNoSetGutFrame);
	free ((char *)S2UI32Neg);
	free ((char *)S2UI32TooBig);
	free ((char *)S2UI32Invalid);
	free ((char *)BasicColorWindowHeading1);
	free ((char *)ColorWindowHeading2);
	free ((char *)ColorWindowHeading3);
	free ((char *)ColorWindowHeading4);
	free ((char *)ColorWindowHeading5);
	free ((char *)ColorWindowHeading6);
	free ((char *)ColorWindowHeading7);
	free ((char *)DemoRoNo);
	free ((char *)RoBadMsg);
	free ((char *)BarColorTitle);
	free ((char *)DemoButtonLable);
	free ((char *)DemoRadio1Lable);
	free ((char *)DemoRadio2Lable);
	free ((char *)DemoRadio3Lable);
	free ((char *)DemoRadioFailInit);
	free ((char *)DemoCheckBoxLable);
	free ((char *)DemoSTatusBarLeadLable);
	free ((char *)DemoSTatusBarTrailLable);
	free ((char *)StringGadgetLable);
	free ((char *)TextGadgetLable);
	free ((char *)ListViewGadgetLable);
	free ((char *)ListViewSample1);
	free ((char *)ListViewSample2);
	free ((char *)ListViewSample3);
	free ((char *)SelectFromList);
	free ((char *)InvokeFromList);
	free ((char *)UInt32GadgetLable);
	free ((char *)FloatGadgetLable);
	free ((char *)DemoRoLable);
	free ((char *)DemoTextItemText);
	free ((char *)BadSpecItemKind);
	free ((char *)BadSpecKindQR);
	free ((char *)BadSpecKindColorSetView);
	free ((char *)BadSpecKindColorSetHigh);
	free ((char *)BadSpecKindColorSetLow);
	free ((char *)DisplayBColorControls);
	free ((char *)DisplayroColourWells);
	free ((char *)BasicColorWindowTitle);
	free ((char *)NoBasicColorWindow);
	free ((char *)NoSpecColorWindow);
	free ((char *)FailPUMInitFontWindow);
	free ((char *)FailPUMInitEditWindow);
	free ((char *)FailPUMInit);
	free ((char *)FailRadioInit);
	free ((char *)hasStr);
	free ((char *)howManyQStr);
	free ((char *)howManyStr);
	free ((char *)howMany4Str);
	free ((char *)fineStr);
	free ((char *)PUMMinOriginStarClass);
	free ((char *)PUMMinOriginPlanetCharacteristic);
	free ((char *)PUMMinMinHabitableStarClass);
	free ((char *)PUMMinMinHabitablePlanetCharacteristic);
	free ((char *)PUMMinMaxHabitableStarClass);
	free ((char *)PUMMinMaxHabitablePlanetCharacteristic);
	free ((char *)PUMMaxOriginStarClass);
	free ((char *)PUMMaxOriginPlanetCharacteristic);
	free ((char *)PUMMaxMinHabitableStarClass);
	free ((char *)PUMMaxMinHabitablePlanetCharacteristic);
	free ((char *)PUMMaxMaxHabitableStarClass);
	free ((char *)PUMMaxMaxHabitablePlanetCharacteristic);
	free ((char *)UInt32GadgetMinOriginOrbit);
	free ((char *)UInt32GadgetMaxOriginOrbit);
	free ((char *)UInt32GadgetMinMinHabitableOrbit);
	free ((char *)UInt32GadgetMinMaxHabitableOrbit);
	free ((char *)UInt32GadgetMaxMinHabitableOrbit);
	free ((char *)UInt32GadgetMaxMaxHabitableOrbit);
	free ((char *)TViewDescription);
	free ((char *)truncShort);
	free((char *)noCCenabled);
	free((char *)BMsgFindXFailSmallConstantsLoad);
	for (	uint32 i = 0;
		i < NUMSTARCLASSES;
		i++)
	{	
	free ((char *)starClassStr[i]);
	}
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)thingStr[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)editThe[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)designThe[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)defaultThe[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS + 1;
		i++)
	{	
		free ((char *)kindStr[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)FailCreate[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)FailNameUnique[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)nothingToSave[i]);
	}	
	for (	uint32 i = 0;
		i < NUMSPECIFICWINDOWS;
		i++)
	{	
		free ((char *)lvwTitleStr[i]);
	}	
	for (	uint32 i = 0;
		i < 14;
		i++)
	{	
		free ((char *)buttonLabels[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)getSomeWindowTitleStr[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)getSomeTitleStr[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)ofTheStr[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)howManyType[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)sstWindowTitle[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)sstTitle[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)lvTitleStr[i]);
	}	
	for (	uint32 i = 0;
		i < NUMTHINGS;
		i++)
	{	
		free ((char *)lvwts[i]);
	}	
}//end


uint32
ui32RandBetween(	uint32 a,
					uint32 b)
{
	return a;
	//debug not very random!!
}//end
